package com.cw.uhf;

import java.awt.CardLayout;
import java.awt.Dialog.ModalExclusionType;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.OutputStreamWriter;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import com.cw.uhf.container.BaseContainer;
import com.cw.uhf.container.ConfigContainer;
import com.cw.uhf.container.FirmwareUpgradeContainer;
import com.cw.uhf.container.InventoryContainer;
import com.cw.uhf.container.LockKillContainer;
 
import com.cw.uhf.container.ReadWriteContainer;
import com.cw.uhf.container.TemperatureContainer;
import com.cw.uhf.container.UHFInfoContainer;
import com.cw.uhf.util.StringUtils;
import com.rscja.deviceapi.Device;
import com.rscja.deviceapi.RFIDWithUHFNetwork;
import com.rscja.deviceapi.RFIDWithUHFUART;
import com.rscja.deviceapi.RFIDWithUHFUsb;
import com.rscja.deviceapi.interfaces.IUHF;
import com.rscja.utility.SystemOut;

public class UHFDemo extends JFrame {

  static {
	   //System.loadLibrary("usb_my");
	 
	    // System.load("/home/cw/cw/uhf/printLog/3333libs/x86_64/libDeviceAPI.so");   
	  
 	     String  filePath=new File("").getAbsolutePath();
	     System.load(filePath+File.separator+"libDeviceAPI.so");   
 
//	    System.load("/home/cw/cw/uhf/printLog/222222libs/x86_64/libDeviceAPI.so");  
 //	    System.load("/home/cw/cw/uhf/printLog/222222libs/libDeviceAPI.so");  
      //  System.load("/home/libDeviceAPI.so");
	   //System.loadLibrary("DeviceAPI");
  
	}

	public static ResourceBundle rs = ResourceBundle.getBundle("language", Locale.CHINA);
	
	private static final int FLAG_TAB = 0;

	private JTabbedPane mTabbedPane;
	private JPanel currContentPane;

	private List<JPanel> mJPanels = new ArrayList<JPanel>();

	public static IUHF uhfReader;
	
	public static ExecutorService mExecutorService;
	
	private JButton btnOpenClose;
	private JLabel languageJLabel;

	private InventoryContainer inventoryContainer;
	private ReadWriteContainer readWriteContainer;
	private ConfigContainer configContainer;
	private LockKillContainer lockKillContainer;
	private BaseContainer uhfInfoContainer;
	private BaseContainer temperatureContainer;
	private FirmwareUpgradeContainer firmwareUpgradeContainer;
 
	
	private JLabel labelComm, labelSerial;
	private JComboBox comboBoxComm; // 通信方式
	private JComboBox comboBoxPort; // 输入的串口路径
	private JPanel panelSerial, panelNetwork;
	private JTextField textFieldIP, textFieldPort;
	
	private DefaultComboBoxModel comboBoxCommModel;
	
	private JComboBox comboBoxLanguage;
	private JTextField textFieldUserPwd;
	private JLabel labelUser;
	
	private static void printCharset() {
		System.out.println("********************************************");
		System.out.println("Default Charset=" + Charset.defaultCharset());
        System.out.println("file.encoding=" + System.getProperty("file.encoding"));
        System.out.println("Default Charset=" + Charset.defaultCharset());
        System.out.println("Default Charset in Use=" + getDefaultCharSet());
		System.out.println("********************************************"); 
	}
	
	private static String getDefaultCharSet() {
        OutputStreamWriter writer = new OutputStreamWriter(new ByteArrayOutputStream());
        String enc = writer.getEncoding();
        return enc;
    }
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		System. setProperty("java.awt.headless", "false"); 
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					UHFDemo frame = new UHFDemo();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public UHFDemo() {
		setResizable(false);
		uhfReader = RFIDWithUHFUART.getInstance();
		mExecutorService = Executors.newCachedThreadPool();
		setModalExclusionType(ModalExclusionType.APPLICATION_EXCLUDE);
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				// TODO Auto-generated method stub
				super.windowClosing(e);
				freeUHF();
				mExecutorService.shutdownNow();
				mExecutorService = null;
				configContainer.clearResetSoftListener();
			}
		});
		
		setTitle("UHF桌面软件(Linux)");
		setBounds(320, 100, 1105, 850);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		getContentPane().setLayout(null);

		mTabbedPane = new JTabbedPane(JTabbedPane.TOP);
		mTabbedPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
		mTabbedPane.setFont(new Font("Dialog", Font.BOLD, 18));
		mTabbedPane.setBounds(12, 12, 1260, 28);
		mTabbedPane.setUI(new MyTabbedPaneUI("#00ff0000", "#0000ff00"));
//		mTabbedPane.setUI(new BasicTabbedPaneUI());
		getContentPane().add(mTabbedPane);

		JPanel panel_2 = new JPanel();
		panel_2.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		panel_2.setBounds(12, 41, 1260, 60);
		getContentPane().add(panel_2);
		panel_2.setLayout(null);
		
		labelComm = new JLabel("通信方式", JLabel.RIGHT);
		labelComm.setBounds(5, 14, 110, 30);
		panel_2.add(labelComm);
		
		comboBoxCommModel = new DefaultComboBoxModel(new String[] { rs.getString("serial"), rs.getString("network"),rs.getString("usb") }); 
		comboBoxComm = new JComboBox(comboBoxCommModel);
		comboBoxComm.setBounds(120, 14, 110, 30);
		panel_2.add(comboBoxComm);
		comboBoxComm.addItemListener(new ItemListener() {
			
			@Override
			public void itemStateChanged(ItemEvent e) {
				// TODO Auto-generated method stub
				if(isSerial()) {
					uhfReader = RFIDWithUHFUART.getInstance();
					panelSerial.setVisible(true);
					panelNetwork.setVisible(false);
				} else if (isNetwork()) {
					uhfReader = RFIDWithUHFNetwork.getInstance();
					panelSerial.setVisible(false);
					panelNetwork.setVisible(true);
				}else if(isUSB()) {
					uhfReader = RFIDWithUHFUsb.getInstance();
					panelNetwork.setVisible(false);
					panelSerial.setVisible(false);
				}
			}
		});
		
		panelSerial = new JPanel();
		panelSerial.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		panelSerial.setBounds(240, 0, 500, 60);
		panel_2.add(panelSerial);
		panelSerial.setLayout(null);
		
		labelSerial = new JLabel("串口", JLabel.RIGHT);
		labelSerial.setBounds(5, 14, 80, 30);
		panelSerial.add(labelSerial);
		
		comboBoxPort = new JComboBox();
		comboBoxPort.setBounds(90, 14, 140, 30);
		panelSerial.add(comboBoxPort);
		comboBoxPort.setModel(new DefaultComboBoxModel(new String[] {"/dev/ttyS1", "/dev/ttyS2", "/dev/ttyS3", "/dev/ttyUSB0", "/dev/ttyUSB1", "/dev/ttyUSB2", "/dev/ttyUSB3"}));
		comboBoxPort.setEditable(true);
		
		labelUser = new JLabel("Linux用户密码", JLabel.RIGHT);
		labelUser.setBounds(250, 14, 140, 30);
		panelSerial.add(labelUser);
		
		textFieldUserPwd = new JPasswordField();
		textFieldUserPwd.setBounds(395, 14, 90, 30);
		panelSerial.add(textFieldUserPwd);
		textFieldUserPwd.setColumns(10);
		
		panelNetwork = new JPanel();
		panelNetwork.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		panelNetwork.setBounds(240, 0, 500, 60);
		panel_2.add(panelNetwork);
		panelNetwork.setLayout(null);
		panelNetwork.setVisible(false);
		
		JLabel labelIP = new JLabel("IP", JLabel.RIGHT);
		labelIP.setBounds(45, 14, 40, 30);
		panelNetwork.add(labelIP);
		
		textFieldIP = new JTextField();
		textFieldIP.setText("192.168.99.202");
		textFieldIP.setBounds(90, 14, 180, 30);
		panelNetwork.add(textFieldIP);
		textFieldIP.setColumns(10);
		
		JLabel labelPort = new JLabel("Port", JLabel.RIGHT);
		labelPort.setBounds(290, 14, 60, 30);
		panelNetwork.add(labelPort);
		
		textFieldPort = new JTextField();
		textFieldPort.setText("8888");
		textFieldPort.setBounds(355, 14, 130, 30);
		panelNetwork.add(textFieldPort);
		textFieldPort.setColumns(10);

		btnOpenClose = new JButton("打开");
		btnOpenClose.setBounds(750, 14, 90, 30);
		panel_2.add(btnOpenClose);
		btnOpenClose.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseClicked(MouseEvent e) {
				// TODO Auto-generated method stub
				if (e.getComponent().isEnabled()) {
					powerOnAction();
				}
			}
		});

		languageJLabel = new JLabel("Language", JLabel.RIGHT);
		languageJLabel.setBounds(865, 14, 80, 30);
		panel_2.add(languageJLabel);

		comboBoxLanguage = new JComboBox();
		comboBoxLanguage.setModel(new DefaultComboBoxModel(new String[] { "中文", "English" }));
		comboBoxLanguage.setBounds(950, 14, 96, 30);
		panel_2.add(comboBoxLanguage);
		comboBoxLanguage.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				int index = comboBoxLanguage.getSelectedIndex();
				if (index == 0) {
					rs = ResourceBundle.getBundle("language", Locale.CHINA);
					Locale.setDefault(new Locale("zh", "CN"));
					JOptionPane.setDefaultLocale(new Locale("zh", "CN"));
				} else {
					rs = ResourceBundle.getBundle("language", Locale.ENGLISH);
					Locale.setDefault(new Locale("en", "US"));
					JOptionPane.setDefaultLocale(new Locale("en", "US"));
				}
				updateLanguageUI();
			}
		});

		addInventoryTab(); // 0
		addReadWriteTab(); // 1
		addConfigTab(); // 2
		addLockKillTab(); // 3
		addUHFInfoTab(); // 4
		addTempratureTab(); // 5
		addFirmwareUpgradeTab();//6
	 
		showTabPanel(0);
		
//		currContentPane = mJPanels.get(0);
//		getContentPane().add(currContentPane);

		mTabbedPane.addChangeListener(new ChangeListener() {

			@Override
			public void stateChanged(ChangeEvent e) {
				// TODO Auto-generated method stub
				showTabPanel(mTabbedPane.getSelectedIndex());
			}
		});
	}
	
	/**
	 * get the edit port
	 * @return
	 */
	private String getPortPath() {
		return comboBoxPort.getEditor().getItem().toString();
	}

	private void updateLanguageUI() {
		setTitle(rs.getString("app_title"));
		labelComm.setText(rs.getString("communication"));
		labelSerial.setText(rs.getString("serial"));
		int selectedIndex = isSerial() ? 0:isNetwork()? 1 : 2; // 记录上次选中index
		comboBoxComm.setModel(new DefaultComboBoxModel(new String[] { rs.getString("serial"), rs.getString("network"),rs.getString("usb")}));
		comboBoxComm.setSelectedIndex(selectedIndex);
		if(comboBoxPort.isEnabled()) {
			btnOpenClose.setText(rs.getString("open"));
		} else {
			btnOpenClose.setText(rs.getString("close"));
		}
		languageJLabel.setText(rs.getString("language"));
		labelUser.setText(rs.getString("linuxUserPwd"));
		mTabbedPane.setTitleAt(0, rs.getString("inventory"));
		mTabbedPane.setTitleAt(1, rs.getString("readWrite"));
		mTabbedPane.setTitleAt(2, rs.getString("config"));
		mTabbedPane.setTitleAt(3, rs.getString("lockKill"));
		mTabbedPane.setTitleAt(4, rs.getString("UHF_info"));
		mTabbedPane.setTitleAt(5, rs.getString("temperatureTitle"));
		mTabbedPane.setTitleAt(6, rs.getString("firmwareUpgradeTitle"));
		
		inventoryContainer.updateLanguageUI();
		readWriteContainer.updateLanguageUI();
		configContainer.updateLanguageUI();
		lockKillContainer.updateLanguageUI();
		uhfInfoContainer.updateLanguageUI();
		temperatureContainer.updateLanguageUI();
		firmwareUpgradeContainer.updateLanguageUI();
	 
	}
	
	private Runnable getIPAndPortRunnable = new Runnable() {
		
		@Override
		public void run() {
			// TODO Auto-generated method stub
			if (uhfReader != null) {
				String[] ipAndPort = uhfReader.getIPAndPort();
				if(ipAndPort != null && ipAndPort.length >= 2) {
					SystemOut.println(ipAndPort[0] + ",----------------------------------------" + ipAndPort[1]);
					textFieldIP.setText(ipAndPort[0]);
					textFieldPort.setText(ipAndPort[1]);
				}
			}
		}
	};
	
	public static String mVersion;
	private Runnable getVersionRunnable = new Runnable() {
		
		@Override
		public void run() {
			// TODO Auto-generated method stub
			if (uhfReader != null) {
				mVersion = uhfReader.getVersion();
				mVersion+="\n version:"+uhfReader.getVersionCode();
				uhfInfoContainer.setMessage(String.format(rs.getString("version"), mVersion));
			}
		}
	};
	
	public static int mTemperature;
	private Runnable getTempRunnable = new Runnable() {
		
		@Override
		public void run() {
			// TODO Auto-generated method stub
			if (uhfReader != null) {
				mTemperature = uhfReader.getTemperature();
				temperatureContainer.setMessage(String.format(rs.getString("temperature"), mTemperature));
			}
		}
	};

	private void showTabPanel(int index) {
		for (int i = 0; i < mJPanels.size(); i++) {
			if (i == index) {
				mJPanels.get(i).setVisible(true);
			} else {
				mJPanels.get(i).setVisible(false);
			}
		}

		if(mTabbedPane.getSelectedIndex() == 2) {
			configContainer.getConfigParams(100);
		} else if (mTabbedPane.getSelectedIndex() == 4) {
			mExecutorService.execute(getVersionRunnable);
		} else if (mTabbedPane.getSelectedIndex() == 5) {
			mExecutorService.execute(getTempRunnable);
		} 
	}
	
	private void setBtnsEnabled(boolean enabled) {
		inventoryContainer.setBtnsEnabled(enabled);
		readWriteContainer.setBtnsEnabled(enabled);
		configContainer.setBtnsEnabled(enabled);
		lockKillContainer.setBtnsEnabled(enabled);
		firmwareUpgradeContainer.setBtnsEnabled(enabled); 
 
	}
	
	private boolean isSerial() {
		return comboBoxComm.getSelectedIndex() == 0;
	}
	
	private boolean isNetwork() {
		return comboBoxComm.getSelectedIndex() == 1;
	}
	
	private boolean isUSB() {
		return comboBoxComm.getSelectedIndex() == 2;
	}
	private void powerOnAction() {
		try {
			String userPassword = textFieldUserPwd.getText();
			String portPath = getPortPath();
			String ip = textFieldIP.getText();
			String portString = textFieldPort.getText();
			
			if(isSerial()) { // 串口通信
				if (StringUtils.isEmpty(portPath)) {
					JOptionPane.showMessageDialog(getContentPane(), rs.getString("msg_enter_serial_path"), rs.getString("powerOn"), JOptionPane.ERROR_MESSAGE);
					return;
				} else if (StringUtils.isEmpty(userPassword)) {
					
				} else {
					cmdUSB(userPassword, portPath); // 执行获取USB串口权限
				}
			} else if(isNetwork()) { // 网络通信
				if (StringUtils.isEmpty(ip)) {
					JOptionPane.showMessageDialog(getContentPane(), rs.getString("msg_ip_cannot_be_null"), rs.getString("connect"), JOptionPane.ERROR_MESSAGE);
					return;
				} else if (!StringUtils.isIPAddress(ip)) {
					JOptionPane.showMessageDialog(getContentPane(), rs.getString("msg_ip_is_incorrect"), rs.getString("connect"), JOptionPane.ERROR_MESSAGE);
					return;
				} else if (StringUtils.isEmpty(portString)) {
					JOptionPane.showMessageDialog(getContentPane(), rs.getString("msg_port_cannot_be_null"), rs.getString("connect"), JOptionPane.ERROR_MESSAGE);
					return;
				} else if (StringUtils.toInt(portString, -1) < 0) {
					JOptionPane.showMessageDialog(getContentPane(), rs.getString("msg_port_is_incorrect"), rs.getString("connect"), JOptionPane.ERROR_MESSAGE);
					return;
				}
			}else if(isUSB()){// usb通信
				
			}

			if (btnOpenClose.getText().equals(rs.getString("open"))) {
				boolean res = false;
				if(isSerial()) {
					res = uhfReader.init(portPath);
				} else if(isNetwork()) {
					res = ((RFIDWithUHFNetwork) uhfReader).init(ip, StringUtils.toInt(portString, -1));
				}else if(isUSB()){
					res =  uhfReader.init("");  
				}
				if (res) {
					if(isSerial()) {
						mExecutorService.execute(getIPAndPortRunnable);
					}
					onPower(true);
				} else if (isSerial()) {
					JOptionPane.showMessageDialog(getContentPane(), rs.getString("msg_init_fail"), rs.getString("powerOn"), JOptionPane.ERROR_MESSAGE);
				} else if(isNetwork()) {
					JOptionPane.showMessageDialog(getContentPane(), rs.getString("msg_connect_fail"), rs.getString("connect"), JOptionPane.ERROR_MESSAGE);
				}else if(isUSB()){
					JOptionPane.showMessageDialog(getContentPane(), rs.getString("msg_connect_fail"), rs.getString("connect"), JOptionPane.ERROR_MESSAGE);
				}
			} else {
				if (freeUHF()) {
					onPower(false);
				}
			}
		} catch (Exception e) {
			// TODO: handle exception
			System.out.println(e.getMessage());
			JOptionPane.showMessageDialog(getContentPane(), rs.getString("msg_init_fail") + "\n" + e.getMessage(), rs.getString("powerOn"), JOptionPane.ERROR_MESSAGE);
		}
	}
	
	private void onPower(boolean onOpen) {
		if(onOpen) {
			btnOpenClose.setText(rs.getString("close"));
		} else {
			btnOpenClose.setText(rs.getString("open"));
		}
		setBtnsEnabled(onOpen);
		
		comboBoxComm.setEnabled(!onOpen);
		comboBoxPort.setEnabled(!onOpen);
		textFieldUserPwd.setEnabled(!onOpen);
		textFieldIP.setEnabled(!onOpen);
		textFieldPort.setEnabled(!onOpen);
		
		if(onOpen && mTabbedPane.getSelectedIndex() == 2) {
			configContainer.getConfigParams(200);; // 获取参数
		}
	}

	private boolean freeUHF() {
		boolean res = true;
		try {
			if (uhfReader != null && ((Device) uhfReader).isPowerOn()) {
				inventoryContainer.stopInventory();
				res = uhfReader.free();
				System.out.println("UHF free result:" + res);
			}
		} catch (Exception e) {
			// TODO: handle exception
		}
		return res;
	}

	/**
	 * 添加盘点标签页
	 */
	private void addInventoryTab() {
		JPanel panelInventory = new TabPanel();
		mTabbedPane.addTab("盘点", null, panelInventory, "EPC");
		panelInventory.setLayout(null);

		inventoryContainer = new InventoryContainer();
		inventoryContainer.setInventoryListener(new InventoryContainer.InventoryListener() {
			
			@Override
			public void onStop() {
				// TODO Auto-generated method stub
				comboBoxLanguage.setEnabled(true);
			}
			
			@Override
			public void onStart() {
				// TODO Auto-generated method stub
				comboBoxLanguage.setEnabled(false);
			}
		});
		
		getContentPane().add(inventoryContainer);
		mJPanels.add(inventoryContainer);
	}

	/**
	 * 添加读与写标签页
	 */
	private void addReadWriteTab() {
		JPanel panelReadWrite = new TabPanel();
		mTabbedPane.addTab("读与写", null, panelReadWrite, null);
		panelReadWrite.setLayout(new CardLayout(0, 0));

		readWriteContainer = new ReadWriteContainer();

		getContentPane().add(readWriteContainer);
		mJPanels.add(readWriteContainer);
	}

	/**
	 * 添加配置标签页
	 */
	private void addConfigTab() {
		JPanel panelConfig = new TabPanel();
		mTabbedPane.addTab("配置", null, panelConfig, null);
		panelConfig.setLayout(new CardLayout(0, 0));

		configContainer = new ConfigContainer();
		configContainer.addResetSoftListener(new ConfigContainer.ResetSoftListener() {
			
			@Override
			public void onResetSucc() {
				// TODO Auto-generated method stub
				SystemOut.println("onResetSucc");
				if (freeUHF()) {
					onPower(false);
				}
			}
			
			@Override
			public void onResetFail() {
				// TODO Auto-generated method stub
				
			}
		});

		getContentPane().add(configContainer);
		mJPanels.add(configContainer);
	}

	/**
	 * 添加锁与销毁标签页
	 */
	private void addLockKillTab() {
		JPanel panelLockKill = new TabPanel();
		mTabbedPane.addTab("锁与销毁", null, panelLockKill, null);
		panelLockKill.setLayout(new CardLayout(0, 0));

		lockKillContainer = new LockKillContainer();

		getContentPane().add(lockKillContainer);
		mJPanels.add(lockKillContainer);

	}

	/**
	 * UHF信息
	 */
	private void addUHFInfoTab() {
		JPanel panelInfo = new TabPanel();
		mTabbedPane.addTab("UHF信息", null, panelInfo, null);
		panelInfo.setLayout(new CardLayout(0, 0));

		uhfInfoContainer = new UHFInfoContainer();

		getContentPane().add(uhfInfoContainer);
		mJPanels.add(uhfInfoContainer);
	}

	/**
	 * UHF温度
	 */
	private void addTempratureTab() {
		JPanel panelTemp = new TabPanel();
		mTabbedPane.addTab("温度", null, panelTemp, null);
		panelTemp.setLayout(new CardLayout(0, 0));

		temperatureContainer = new TemperatureContainer();

		getContentPane().add(temperatureContainer);
		mJPanels.add(temperatureContainer);
	}
	/*
	 * 固件升级
	 * */
	private void addFirmwareUpgradeTab() {
		JPanel panelTemp = new TabPanel();
		mTabbedPane.addTab("固件升级", null, panelTemp, null);
		panelTemp.setLayout(new CardLayout(0, 0));

		firmwareUpgradeContainer = new FirmwareUpgradeContainer();

		getContentPane().add(firmwareUpgradeContainer);
		mJPanels.add(firmwareUpgradeContainer);
	}
	
	 
	
	private void cmdUSB(String userPassword, String portPath) {
		try {
			String shpath = "src/usb.sh";
			String[] path = new String[] { "sh", shpath, userPassword, portPath }; 
//			Process ps = Runtime.getRuntime().exec(shpath);
			Process ps = Runtime.getRuntime().exec(path);
			int status = ps.waitFor();
			System.out.println("status=" + status + ", pwd=" + userPassword + ", port=" + portPath);

		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
