package com.cw.uhf.container;

import java.awt.Font;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.UIManager;

import com.cw.uhf.UHFDemo;
import com.cw.uhf.util.NumberTool;
import com.cw.uhf.util.StringUtils;
import com.rscja.deviceapi.RFIDWithUHFUART;
import com.rscja.deviceapi.interfaces.IUHF;

public class BaseContainer extends JPanel {

//	public IUHF uhfReader;
	
	protected JLabel filterLabel, dataFilter, startAddressLabel, lengthLabel;
	
	protected JTextField textFieldData;
	protected JTextField textFieldStartAddress;
	protected JTextField textFieldLength;
	
	public JRadioButton rdbtnEpc;
	public JRadioButton rdbtnTid;
	public JRadioButton rdbtnUser;

	public JButton buttonSet;
	public JButton buttonReset;
	
	public BaseContainer() {
		if(!isPrivate()) {
			init();
		}
	}
	
	private void init() {
		JPanel panel = new JPanel();
		panel.setBackground(UIManager.getColor("Label.disabledShadow"));
		panel.setBounds(0, 0, 1060, 82);
		panel.setLayout(null);
		add(panel);

		JPanel panel_3 = new JPanel();
		panel_3.setBackground(UIManager.getColor("Label.disabledShadow"));
		panel_3.setBounds(0, 0, 1060, 27);
		panel.add(panel_3);
		panel_3.setLayout(null);
		
		filterLabel = new JLabel("过滤");
		filterLabel.setFont(new Font("Dialog", Font.BOLD, 16));
		filterLabel.setBounds(12, 0, 80, 25);
		panel_3.add(filterLabel);

		JPanel panel_4 = new JPanel();
		panel_4.setBackground(UIManager.getColor("Label.disabledShadow"));
		panel_4.setBounds(0, 27, 1060, 55);
		panel.add(panel_4);
		panel_4.setLayout(null);

		dataFilter = new JLabel("数据：", JLabel.CENTER);
		dataFilter.setBounds(12, 12, 40, 25);
		panel_4.add(dataFilter);

		textFieldData = new JTextField();
		textFieldData.setBounds(52, 12, 160, 29);
		panel_4.add(textFieldData);
		textFieldData.setColumns(10);

		startAddressLabel = new JLabel("起始地址：", JLabel.CENTER);
		startAddressLabel.setBounds(232, 12, 98, 25);
		panel_4.add(startAddressLabel);
		
		KeyAdapter numberKeyAdapter = new KeyAdapter() {
			public void keyTyped(KeyEvent e) {
				char keyChar = e.getKeyChar();				
				if(!(keyChar >= '0' && keyChar <= '9')){
					e.consume(); //缺点，不能控制赋值黏贴的内容
				}
			}
		};

		textFieldStartAddress = new JTextField();
		textFieldStartAddress.setText("32");
		textFieldStartAddress.setBounds(330, 10, 40, 29);
		panel_4.add(textFieldStartAddress);
		textFieldStartAddress.setColumns(10);
		textFieldStartAddress.addKeyListener(numberKeyAdapter);
		
		JLabel labelBit = new JLabel("(bit)");
		labelBit.setBounds(370, 12, 40, 25);
		panel_4.add(labelBit);

		lengthLabel = new JLabel("长度：", JLabel.CENTER);
		lengthLabel.setBounds(410, 12, 50, 25);
		panel_4.add(lengthLabel);

		textFieldLength = new JTextField();
		textFieldLength.setText("0");
		textFieldLength.setBounds(460, 10, 40, 29);
		panel_4.add(textFieldLength);
		textFieldLength.setColumns(10);
		textFieldLength.addKeyListener(numberKeyAdapter);
		
		labelBit = new JLabel("(bit)");
		labelBit.setBounds(500, 12, 40, 25);
		panel_4.add(labelBit);

		JPanel panelBank = new JPanel();
		panelBank.setBackground(UIManager.getColor("RadioButton.focus"));
		panelBank.setBounds(560, 8, 200, 33);
		panelBank.setLayout(null);
		panel_4.add(panelBank);
		
		ButtonGroup btnGroup = new ButtonGroup();
		
		ItemListener itemListener = new ItemListener() {
			
			@Override
			public void itemStateChanged(ItemEvent e) {
				// TODO Auto-generated method stub
				if(e.getSource() == rdbtnEpc) {
					textFieldStartAddress.setText("32");
				} else {
					textFieldStartAddress.setText("0");
				}
			}
		};
		
		rdbtnEpc = new JRadioButton("EPC");
		rdbtnEpc.setSelected(true);
		rdbtnEpc.setBounds(0, 0, 60, 33);
		rdbtnEpc.addItemListener(itemListener);
		panelBank.add(rdbtnEpc);
		rdbtnEpc.setBackground(UIManager.getColor("#00ffffff"));
		btnGroup.add(rdbtnEpc);

		rdbtnTid = new JRadioButton("TID");
		rdbtnTid.setBounds(70, 0, 60, 33);
		rdbtnTid.addItemListener(itemListener);
		panelBank.add(rdbtnTid);
		rdbtnTid.setBackground(UIManager.getColor("#00ffffff"));
		btnGroup.add(rdbtnTid);

		rdbtnUser = new JRadioButton("User");
		rdbtnUser.setBounds(140, 0, 60, 33);
		rdbtnUser.addItemListener(itemListener);
		panelBank.add(rdbtnUser);
		rdbtnUser.setBackground(UIManager.getColor("#00ffffff"));
		btnGroup.add(rdbtnUser);

		if (showFilterButtons()) {
			buttonSet = new JButton("设置");
			buttonSet.setEnabled(false);
			buttonSet.setBounds(780, 7, 80, 35);
			buttonSet.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
					if(!e.getComponent().isEnabled()) {
						return;
					}
					String startAddressString = textFieldStartAddress.getText();
					String length = textFieldLength.getText();
					if(startAddressString.isEmpty()) {
					    JOptionPane.showMessageDialog(BaseContainer.this, UHFDemo.rs.getString("msg_please_input_start_address"), UHFDemo.rs.getString("filter"), JOptionPane.WARNING_MESSAGE);
					    return;
					} else if(length.isEmpty()) {
					    JOptionPane.showMessageDialog(BaseContainer.this, UHFDemo.rs.getString("msg_please_enter_the_length"), UHFDemo.rs.getString("filter"), JOptionPane.WARNING_MESSAGE);
					    return;
					}
					
					int bank = RFIDWithUHFUART.Bank_EPC;
	                if (rdbtnEpc.isSelected()) {
	                    bank = RFIDWithUHFUART.Bank_EPC;
	                } else if (rdbtnTid.isSelected()) {
	                    bank = RFIDWithUHFUART.Bank_TID;
	                }

	                int ptr = StringUtils.toInt(startAddressString, -1);
	                int len = StringUtils.toInt(length, -1);
	                String data = textFieldData.getText();
	                if (ptr == -1 || len == -1) {
//	                    UIHelper.ToastMessage(mContext, R.string.uhf_msg_set_filter_fail);
					    JOptionPane.showMessageDialog(BaseContainer.this, UHFDemo.rs.getString("msg_set_filter_fail"), UHFDemo.rs.getString("filter"), JOptionPane.ERROR_MESSAGE);
	                } else {
	                    if (len > 0) {
	                        if (data == null)
	                            data = "";
	                        int flag = len / 8 + (len % 8 == 0 ? 0 : 1);
	                        int dataLen = data.replace(" ", "").length() / 2;
	                        if (dataLen < flag) {
//	                            UIHelper.ToastMessage(mContext, R.string.uhf_msg_set_filter_fail2);
	    					    JOptionPane.showMessageDialog(BaseContainer.this, UHFDemo.rs.getString("msg_set_filter_fail"), UHFDemo.rs.getString("filter"), JOptionPane.ERROR_MESSAGE);
	                            return;
	                        }
	                    }

	                    if (UHFDemo.uhfReader.setFilter(bank, ptr, len, data)) {
//	                        UIHelper.ToastMessage(mContext, R.string.uhf_msg_set_filter_succ);
    					    JOptionPane.showMessageDialog(BaseContainer.this, UHFDemo.rs.getString("msg_set_filter_succ"), UHFDemo.rs.getString("filter"), JOptionPane.INFORMATION_MESSAGE);
	                    } else {
//	                        UIHelper.ToastMessage(mContext, R.string.uhf_msg_set_filter_fail);
    					    JOptionPane.showMessageDialog(BaseContainer.this, UHFDemo.rs.getString("msg_set_filter_fail"), UHFDemo.rs.getString("filter"), JOptionPane.ERROR_MESSAGE);
	                    }
	                }

				}
			});
			panel_4.add(buttonSet);

			buttonReset = new JButton("重置");
			buttonReset.setEnabled(false);
			buttonReset.setBounds(880, 7, 80, 35);
			buttonReset.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseClicked(MouseEvent e) {
					// TODO Auto-generated method stub
					if(!e.getComponent().isEnabled()) {
						return;
					}
                    if (UHFDemo.uhfReader.setFilter(RFIDWithUHFUART.Bank_EPC, 32, 0, "")) {
//                        UIHelper.ToastMessage(mContext, R.string.uhf_msg_set_filter_succ);
                    	textFieldData.setText("");
                    	textFieldStartAddress.setText("32");
                    	textFieldLength.setText("0");
                    	rdbtnEpc.setSelected(true);
					    JOptionPane.showMessageDialog(BaseContainer.this, UHFDemo.rs.getString("msg_reset_succ"), UHFDemo.rs.getString("filter"), JOptionPane.INFORMATION_MESSAGE);
                    } else {
//                        UIHelper.ToastMessage(mContext, R.string.uhf_msg_set_filter_fail);
					    JOptionPane.showMessageDialog(BaseContainer.this, UHFDemo.rs.getString("msg_reset_fail"), UHFDemo.rs.getString("filter"), JOptionPane.ERROR_MESSAGE);
                    }
				}
			});
			panel_4.add(buttonReset);
		}
	}
	
	/**
	 * 更新语言
	 */
	public void updateLanguageUI() {
		if (filterLabel != null)
			filterLabel.setText(UHFDemo.rs.getString("filter"));
		if (dataFilter != null)
			dataFilter.setText(UHFDemo.rs.getString("data"));
		if (startAddressLabel != null)
			startAddressLabel.setText(UHFDemo.rs.getString("startAddress"));
		if (lengthLabel != null)
			lengthLabel.setText(UHFDemo.rs.getString("length"));

		if (buttonSet != null)
			buttonSet.setText(UHFDemo.rs.getString("setup"));
		if (buttonReset != null)
			buttonReset.setText(UHFDemo.rs.getString("reset"));
	}
	
	/**
	 * 设置信息
	 * @param msg
	 */
	public void setMessage(String msg) {
		
	}

	/**
	 * 显示过滤设置按钮
	 * @return
	 */
	protected boolean showFilterButtons() {
		return true;
	}
	
	/**
	 * 是否私有
	 * @return
	 */
	protected boolean isPrivate() {
		return false;
	}
}
