package com.cw.uhf.container;

import java.awt.Color;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.List;

import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.UIManager;

import com.cw.uhf.UHFDemo;
import com.cw.uhf.util.StringUtils;
import com.rscja.deviceapi.Device;
import com.rscja.deviceapi.RFIDWithUHFUsb;
import com.rscja.deviceapi.entity.AntNameEnum;
import com.rscja.deviceapi.entity.AntState;
import com.rscja.deviceapi.interfaces.IUR4;
import com.rscja.utility.SystemOut;

public class ConfigContainer extends BaseContainer {

	private JComboBox comboBoxPower;
	private JComboBox comboBoxFre;
	private JComboBox comboBoxProtocol;

	private JLabel relayLabel ;
	private JLabel input2;
	private JLabel input1;
	private JComboBox cmbRelay,	cmbInput1, cmbInput2 ;
	
	private JLabel powerLabel, freLabel, protocoLabel, beepLabel, labelLocalIP;

	private JRadioButton rdbtnOpen, rdbtnClose;

	private String[] powerStrings = new String[] { "", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15",
			"16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30" };

	private String[] freStrings = new String[] { "", UHFDemo.rs.getString("China1"), UHFDemo.rs.getString("China2"),
			UHFDemo.rs.getString("Europe"), UHFDemo.rs.getString("USA"), UHFDemo.rs.getString("Korea"),
			UHFDemo.rs.getString("Japan")};
	
	private String[] modeStrings = new String[] { "", UHFDemo.rs.getString("commandMode"), UHFDemo.rs.getString("autoMode"),
			UHFDemo.rs.getString("triggerMode")};

	private String[] relayStrings = new String[] {  UHFDemo.rs.getString("relayDisconnect"), UHFDemo.rs.getString("relayClose")};

	private String[] inputStrings = new String[] { "low voltage", "high voltage"};

	
	private JButton btnSetPower, btnGetPower, btnSetFre, btnGetFre, btnSetProtocol, btnGetProtocol, btnSetBeep,
			btnGetBeep, btnSetIPAndPort, btnGetIPAndPort, btnResetSoft,btnTriggerBeep ,btnLedOn,btnLedOff,btnLedSet,btnSetAnt,btnGetAnt
			,btnRelaySet,btnInputGet;

	private JTextField textFieldIP, textFieldPort,txtBeepDT,txtCount,txtIT,txtDT;

	private JCheckBox cbAnt1, cbAnt2, cbAnt3, cbAnt4;
	private MouseAdapter mouseAdapter = new MouseAdapter() {
		public void mouseClicked(MouseEvent e) {
			if (!e.getComponent().isEnabled()) {
				return;
			}
			if (e.getComponent() == btnSetPower) {
				setPower();
			} else if (e.getComponent() == btnGetPower) {
				getPower(true);
			} else if (e.getComponent() == btnSetFre) {
				setFre();
			} else if (e.getComponent() == btnGetFre) {
				getFre(true);
			} else if (e.getComponent() == btnSetProtocol) {
				setProtocol();
			} else if (e.getComponent() == btnGetProtocol) {
				getProtocol(true);
			} else if (e.getComponent() == btnSetBeep) {
				setBeep();
			} else if (e.getComponent() == btnGetBeep) {
				getBeep(true);
			} else if (e.getComponent() == btnSetIPAndPort) {
				setIPAndPort();
			} else if (e.getComponent() == btnGetIPAndPort) {
				getIPAndPort(true);
			} else if (e.getComponent() == btnResetSoft) {
				resetSoft();
			}else if(e.getComponent() == btnTriggerBeep){
				setTriggerBeep();
			}else if(e.getComponent() == btnLedOff) {
				setLEDOff();
			}else if(e.getComponent() == btnLedSet) {
				setBlinkOfLed();
			}else if(e.getComponent() == btnLedOn) {
				setLEDOn();
			}else if(e.getComponent() == btnGetAnt) {
			    getAnt();
			}else if(e.getComponent() == btnSetAnt) {
				setAnt();
			}else if(e.getComponent() == btnRelaySet) {
				setRelay();
			}else if(e.getComponent() == btnInputGet) {
				getInput();
			}
		};
	};
	private JPanel panel_6,panel_7,panel_8,panel_9;

	public ConfigContainer() {
		init();
	}

	public void setBtnsEnabled(boolean enabled) {
		if (buttonSet != null)
			buttonSet.setEnabled(enabled);
		if (buttonReset != null)
			buttonReset.setEnabled(enabled);

		btnSetPower.setEnabled(enabled);
		btnGetPower.setEnabled(enabled);
		btnSetFre.setEnabled(enabled);
		btnGetFre.setEnabled(enabled);
		btnSetProtocol.setEnabled(enabled);
		btnGetProtocol.setEnabled(enabled);
		btnSetBeep.setEnabled(enabled);
		btnGetBeep.setEnabled(enabled);
		btnSetIPAndPort.setEnabled(enabled);
		btnGetIPAndPort.setEnabled(enabled);
		btnResetSoft.setEnabled(enabled);
		btnGetAnt.setEnabled(enabled);
        btnSetAnt.setEnabled(enabled);
		
        btnRelaySet.setEnabled(enabled);
        btnInputGet.setEnabled(enabled);
        
		if(btnTriggerBeep!=null)btnTriggerBeep.setEnabled(enabled);
		if(btnLedOff!=null)btnLedOff.setEnabled(enabled);
		if(btnLedSet!=null)btnLedSet.setEnabled(enabled);
		if(btnLedOn!=null)btnLedOn.setEnabled(enabled);
	}

	private void init() {

		setBackground(UIManager.getColor("Button.highlight"));
		setBounds(12, 102, 1060, 690);
		setLayout(null);

		JPanel panel = new JPanel();
		panel.setBackground(UIManager.getColor("Button.highlight"));
		panel.setBounds(0, 0, 1060, 690);
		panel.setLayout(null);
		add(panel);

		JPanel panel_1 = new JPanel();
		panel_1.setBackground(UIManager.getColor("Label.disabledShadow"));
		panel_1.setBounds(0, 0, 524, 95);
		panel.add(panel_1);
		panel_1.setLayout(null);

		powerLabel = new JLabel("输出功率：");
		powerLabel.setFont(UIManager.getFont("Label.font"));
		powerLabel.setBounds(12, 10, 80, 25);
		panel_1.add(powerLabel);

		comboBoxPower = new JComboBox();
		comboBoxPower.setBounds(87, 5, 352, 34);
		panel_1.add(comboBoxPower);
		comboBoxPower.setModel(new DefaultComboBoxModel(powerStrings));

		btnSetPower = new JButton("Set");
		btnSetPower.setEnabled(false);
		btnSetPower.setBounds(87, 51, 145, 35);
		panel_1.add(btnSetPower);
		btnSetPower.addMouseListener(mouseAdapter);

		btnGetPower = new JButton("Get");
		btnGetPower.setEnabled(false);
		btnGetPower.setBounds(294, 51, 145, 35);
		panel_1.add(btnGetPower);
		btnGetPower.addMouseListener(mouseAdapter);

		JLabel dbmJLabel = new JLabel("dbm");
		dbmJLabel.setBounds(457, 10, 48, 25);
		panel_1.add(dbmJLabel);

		JPanel panel_2 = new JPanel();
		panel_2.setBackground(UIManager.getColor("Label.disabledShadow"));
		panel_2.setLayout(null);
		panel_2.setBounds(536, 0, 524, 95);
		panel.add(panel_2);

		freLabel = new JLabel("频段：");
		freLabel.setBounds(12, 10, 80, 25);
		panel_2.add(freLabel);

		comboBoxFre = new JComboBox();
		comboBoxFre.setModel(new DefaultComboBoxModel(freStrings));
		comboBoxFre.setBounds(95, 5, 365, 34);
		panel_2.add(comboBoxFre);

		btnSetFre = new JButton("Set");
		btnSetFre.setEnabled(false);
		btnSetFre.setBounds(95, 51, 145, 35);
		panel_2.add(btnSetFre);
		btnSetFre.addMouseListener(mouseAdapter);

		btnGetFre = new JButton("Get");
		btnGetFre.setEnabled(false);
		btnGetFre.setBounds(296, 51, 145, 35);
		panel_2.add(btnGetFre);
		btnGetFre.addMouseListener(mouseAdapter);

		JPanel panel_3 = new JPanel();
		panel_3.setBackground(UIManager.getColor("Label.disabledShadow"));
		panel_3.setLayout(null);
		panel_3.setBounds(0, 107, 524, 95);
		panel.add(panel_3);

		protocoLabel = new JLabel("协议：");
		protocoLabel.setBounds(12, 10, 80, 25);
		panel_3.add(protocoLabel);

		comboBoxProtocol = new JComboBox();
		comboBoxProtocol.setModel(new DefaultComboBoxModel(
				new String[] { "", "ISO18000-6C", "GB/T 29768", "GJB 7377.1", "ISO18000-6B" }));
		comboBoxProtocol.setBounds(87, 5, 350, 34);
		panel_3.add(comboBoxProtocol);

		btnSetProtocol = new JButton("Set");
		btnSetProtocol.setEnabled(false);
		btnSetProtocol.setBounds(87, 51, 145, 35);
		panel_3.add(btnSetProtocol);
		btnSetProtocol.addMouseListener(mouseAdapter);

		btnGetProtocol = new JButton("Get");
		btnGetProtocol.setEnabled(false);
		btnGetProtocol.setBounds(292, 51, 145, 35);
		panel_3.add(btnGetProtocol);
		btnGetProtocol.addMouseListener(mouseAdapter);

		JPanel panel_4 = new JPanel();
		panel_4.setBackground(UIManager.getColor("Label.disabledShadow"));
		panel_4.setLayout(null);
		panel_4.setBounds(536, 107, 524, 95);
		panel.add(panel_4);

		beepLabel = new JLabel("蜂鸣器：");
		beepLabel.setBounds(12, 10, 80, 25);
		panel_4.add(beepLabel);

		btnSetBeep = new JButton("Set");
		btnSetBeep.setEnabled(false);
		btnSetBeep.setBounds(95, 47, 145, 35);
		panel_4.add(btnSetBeep);
		btnSetBeep.addMouseListener(mouseAdapter);

		btnGetBeep = new JButton("Get");
		btnGetBeep.setEnabled(false);
		btnGetBeep.setBounds(298, 48, 145, 35);
		panel_4.add(btnGetBeep);
		btnGetBeep.addMouseListener(mouseAdapter);

		ButtonGroup buttonGroup = new ButtonGroup();

		rdbtnOpen = new JRadioButton("Open");
		rdbtnOpen.setBackground(UIManager.getColor("#00ffffff"));
		rdbtnOpen.setBounds(95, 6, 145, 33);
		panel_4.add(rdbtnOpen);
		buttonGroup.add(rdbtnOpen);

		rdbtnClose = new JRadioButton("Close");
		rdbtnClose.setBackground(UIManager.getColor("#00ffffff"));
		rdbtnClose.setBounds(298, 6, 146, 33);
		panel_4.add(rdbtnClose);
		buttonGroup.add(rdbtnClose);

		JPanel panel_5 = new JPanel();
		panel_5.setLayout(null);
		panel_5.setBackground(UIManager.getColor("Button.select"));
		panel_5.setBounds(0, 214, 524, 95);
		panel.add(panel_5);

		labelLocalIP = new JLabel("本地IP：");
		labelLocalIP.setBounds(12, 10, 80, 25);
		panel_5.add(labelLocalIP);

		textFieldIP = new JTextField();
		textFieldIP.setBounds(87, 10, 145, 34);
		panel_5.add(textFieldIP);
		textFieldIP.setColumns(10);

		JLabel labelPort = new JLabel("Port：");
		labelPort.setBounds(292, 10, 60, 25);
		panel_5.add(labelPort);

		textFieldPort = new JTextField();
		textFieldPort.setBounds(352, 10, 85, 34);
		panel_5.add(textFieldPort);
		textFieldPort.setColumns(10);

		btnSetIPAndPort = new JButton("Set");
		btnSetIPAndPort.setEnabled(false);
		btnSetIPAndPort.setBounds(87, 51, 145, 35);
		panel_5.add(btnSetIPAndPort);
		btnSetIPAndPort.addMouseListener(mouseAdapter);

		btnGetIPAndPort = new JButton("Get");
		btnGetIPAndPort.setEnabled(false);
		btnGetIPAndPort.setBounds(292, 51, 145, 35);
		panel_5.add(btnGetIPAndPort);
		btnGetIPAndPort.addMouseListener(mouseAdapter);

		panel_6 = new JPanel();
		panel_6.setBackground(UIManager.getColor("Button.select"));
		panel_6.setBounds(536, 214, 524, 95);
		panel.add(panel_6);
		panel_6.setLayout(null);

		btnResetSoft = new JButton("ResetSoft");
		btnResetSoft.setEnabled(false);
		btnResetSoft.setBounds(23, 25, 476, 45);
		panel_6.add(btnResetSoft);
		btnResetSoft.addMouseListener(mouseAdapter);
		//initLedUI(panel);
		//initBeepUI(panel);
 
		panel_7 = new JPanel();
		panel_7.setBackground(UIManager.getColor("Button.select"));
		panel_7.setBounds(0, 320, 524, 100);
		panel.add(panel_7);
		panel_7.setLayout(null);
		initANtUI();
	 
		 /* 命令模式/自动模式
		panel_8 = new JPanel();
		panel_8.setBackground(UIManager.getColor("Button.select"));
		panel_8.setBounds(0, 430, 524, 100);
		panel.add(panel_8);
		panel_8.setLayout(null);
		initModeUI();
		*/
		 
		panel_9 = new JPanel();
		panel_9.setBackground(UIManager.getColor("Button.select"));
		panel_9.setBounds(536, 319, 524, 100);
		panel.add(panel_9);
		panel_9.setLayout(null);
		initGPIO();	 
	}
	
    private void initGPIO() {
		
		relayLabel = new JLabel("继电器：");
		relayLabel.setBounds(12, 10, 80, 25);
		panel_9.add(relayLabel);

	    cmbRelay = new JComboBox();
		cmbRelay.setModel(new DefaultComboBoxModel(relayStrings));
		cmbRelay.setBounds(95, 5, 200, 34);
		panel_9.add(cmbRelay);
		
		btnRelaySet = new JButton("Set");
		btnRelaySet.setEnabled(false);
		btnRelaySet.setBounds(310, 5, 80, 34);
		panel_9.add(btnRelaySet);
		btnRelaySet.addMouseListener(mouseAdapter);
		//----------------------------
		
	    input1 = new JLabel("输入1：");
		input1.setBounds(12, 50, 80, 25);
		panel_9.add(input1);
		
		cmbInput1 = new JComboBox();
		cmbInput1.setModel(new DefaultComboBoxModel(inputStrings));
		cmbInput1.setBounds(95, 50, 120, 34);
		panel_9.add(cmbInput1);
		
	    input2 = new JLabel("输入2：");
		input2.setBounds(250, 50, 80, 25);
		panel_9.add(input2);
		
		cmbInput2 = new JComboBox();
		cmbInput2.setModel(new DefaultComboBoxModel(inputStrings));
		cmbInput2.setBounds(310, 50, 120, 34);
		panel_9.add(cmbInput2);

		btnInputGet = new JButton("Get");
		btnInputGet.setEnabled(false);
		btnInputGet.setBounds(440, 50, 80, 34);
		panel_9.add(btnInputGet);
		btnInputGet.addMouseListener(mouseAdapter);
		 
	}

	private void initModeUI() {
		
		JLabel freLabel = new JLabel("Mode：");
		freLabel.setBounds(12, 10, 80, 25);
		panel_8.add(freLabel);

		JComboBox cmbMode = new JComboBox();
		cmbMode.setModel(new DefaultComboBoxModel(modeStrings));
		cmbMode.setBounds(95, 5, 200, 34);
		panel_8.add(cmbMode);
		
		JButton modeset = new JButton("Set");
		modeset.setEnabled(false);
		modeset.setBounds(310, 5, 80, 34);
		panel_8.add(modeset);
		modeset.addMouseListener(mouseAdapter);
		
		
		JButton modeget = new JButton("Get");
		modeget.setEnabled(false);
		modeget.setBounds(398, 5, 80, 34);
		panel_8.add(modeget);
		modeget.addMouseListener(mouseAdapter);
	}
	
	private void initLedUI(JPanel panel) {
		//-----------led------------------
		JPanel panel_led = new JPanel();
		panel_led.setLayout(null);
		panel_led.setBackground(UIManager.getColor("Button.select"));
		panel_led.setBounds(0, 320, 800, 160);
		panel.add(panel_led);
		
		JLabel labelDT= new JLabel("LED duration Time：");
		labelDT.setBounds(12, 10, 200, 25);
		panel_led.add(labelDT);

	    txtDT = new JTextField();
		txtDT.setBounds(150, 10, 85, 34);
		panel_led.add(txtDT);
		txtDT.setColumns(10);
		txtDT.setText("1");

		JLabel dtUnit = new JLabel("(unit:10ms)");
		dtUnit.setBounds(235, 10, 150, 25);
		panel_led.add(dtUnit);
		

		JLabel lblinterval = new JLabel("interval Time：");
		lblinterval.setBounds(340, 10, 150, 25);
		panel_led.add(lblinterval);

		txtIT = new JTextField();
		txtIT.setBounds(445, 10, 85, 34);
		panel_led.add(txtIT);
		txtIT.setText("1");
		txtIT.setColumns(10);
		
		JLabel itUnit = new JLabel("(unit:10ms)");      
		itUnit.setBounds(530, 10, 150, 25);
		panel_led.add(itUnit);
		
		JLabel lblcount = new JLabel("count：");
		lblcount.setBounds(630, 10, 150, 25);
		panel_led.add(lblcount);

	    txtCount = new JTextField();
		txtCount.setBounds(680, 10, 85, 34);
		panel_led.add(txtCount);
		txtCount.setText("5");
		txtCount.setColumns(10);

	    btnLedSet = new JButton("Set");
		btnLedSet.setEnabled(false);
		btnLedSet.setBounds(87, 51, 145, 35);
		panel_led.add(btnLedSet);
		btnLedSet.addMouseListener(mouseAdapter);

		JLabel lab = new JLabel("-------------------------------------------------------------------");
		lab.setBounds(20, 90, 500, 25);
		panel_led.add(lab);
		
		btnLedOn= new JButton("led on");
		btnLedOn.setEnabled(false);
		btnLedOn.setBounds(12, 120, 145, 35);
		panel_led.add(btnLedOn);
		btnLedOn.addMouseListener(mouseAdapter);
		
		btnLedOff= new JButton("led Off");
		btnLedOff.setEnabled(false);
		btnLedOff.setBounds(292, 120, 145, 35);
		panel_led.add(btnLedOff);
		btnLedOff.addMouseListener(mouseAdapter);
	}
	
	private void initBeepUI(JPanel panel) {
		
		JPanel panel_beep = new JPanel();
		panel_beep.setLayout(null);
		panel_beep.setBackground(UIManager.getColor("Button.select"));
		panel_beep.setBounds(0, 490, 800, 120);
		panel.add(panel_beep);
		
		JLabel lblinterval = new JLabel("Beep durationTime Time：");
		lblinterval.setBounds(12, 10, 170, 25);
		panel_beep.add(lblinterval);

	    txtBeepDT = new JTextField();
		txtBeepDT.setBounds(185, 10, 85, 34);
		txtBeepDT.setText("1");
		txtBeepDT.setColumns(10);
		panel_beep.add(txtBeepDT);
		
		JLabel itUnit = new JLabel("(unit:10ms)");
		itUnit.setBounds(270, 10, 150, 25);
		panel_beep.add(itUnit);
		
	    btnTriggerBeep = new JButton("set");
		btnTriggerBeep.setEnabled(false);
		btnTriggerBeep.setBounds(87, 50, 145, 35);
		panel_beep.add(btnTriggerBeep);
		btnTriggerBeep.addMouseListener(mouseAdapter);

	 
	}
	

	private void initANtUI() {

		cbAnt1 = new JCheckBox("Ant1");
		cbAnt1.setBounds(10, 10, 100, 20);
		cbAnt1.setBackground(UIManager.getColor("#00ffffff"));
	    panel_7.add(cbAnt1);

		cbAnt2 = new JCheckBox("Ant2");
		cbAnt2.setBounds(110, 10, 100, 20);
		cbAnt2.setBackground(UIManager.getColor("#00ffffff"));
	    panel_7.add(cbAnt2);
	    
		cbAnt3 = new JCheckBox("Ant3");
		cbAnt3.setBounds(210, 10, 100, 20);
		cbAnt3.setBackground(UIManager.getColor("#00ffffff"));
	    panel_7.add(cbAnt3);
	    
		cbAnt4 = new JCheckBox("Ant4");
		cbAnt4.setBounds(310, 10, 100, 20);
		cbAnt4.setBackground(UIManager.getColor("#00ffffff"));
	    panel_7.add(cbAnt4);
	    
	    btnSetAnt = new JButton("Set");
	    btnSetAnt.setBounds(87, 51, 145, 35);
	    btnSetAnt.setBackground(UIManager.getColor("#00ffffff"));
	    btnSetAnt.setEnabled(false);
	    panel_7.add(btnSetAnt);
	    
	    btnGetAnt = new JButton("Get");
	    btnGetAnt.setBounds(292, 51, 145, 35);
	    btnGetAnt.setBackground(UIManager.getColor("#00ffffff"));
	    btnGetAnt.setEnabled(false);
	    panel_7.add(btnGetAnt);
	    
	    btnSetAnt.addMouseListener(mouseAdapter);
		btnGetAnt.addMouseListener(mouseAdapter);
	    
	    
	}
	
	@Override
	public void updateLanguageUI() {
		// TODO Auto-generated method stub
		super.updateLanguageUI();
		powerLabel.setText(UHFDemo.rs.getString("power"));
		protocoLabel.setText(UHFDemo.rs.getString("protocol"));
		freLabel.setText(UHFDemo.rs.getString("frequency"));
		beepLabel.setText(UHFDemo.rs.getString("beep"));
		labelLocalIP.setText(UHFDemo.rs.getString("localIP"));

		freStrings = new String[] { "", UHFDemo.rs.getString("China1"), UHFDemo.rs.getString("China2"),
				UHFDemo.rs.getString("Europe"), UHFDemo.rs.getString("USA"), UHFDemo.rs.getString("Korea"),
				UHFDemo.rs.getString("Japan"), UHFDemo.rs.getString("New_Zealand") };
		comboBoxFre.setModel(new DefaultComboBoxModel(freStrings));
		btnResetSoft.setText(UHFDemo.rs.getString("softReset"));
		
		 relayLabel.setText(UHFDemo.rs.getString("relay"));
		 input2.setText(UHFDemo.rs.getString("input2"));
		 input1.setText(UHFDemo.rs.getString("input1"));
	     relayStrings = new String[] {  UHFDemo.rs.getString("relayDisconnect"), UHFDemo.rs.getString("relayClose")};
		 cmbRelay.setModel(new DefaultComboBoxModel(relayStrings));
		
		
	}

	private void getAnt() {
		
	      if(UHFDemo.uhfReader instanceof IUR4) {
	        	List<AntState> list = ((IUR4)UHFDemo.uhfReader).getAnt();
	        	if(list!=null && list.size()>0) {
	        		for(int k=0;k<list.size();k++) {
	        			AntState ant=list.get(k);
	        			if(ant.getAntName() == AntNameEnum.ANT1) {
	        				cbAnt1.setSelected(ant.isEnable());
	        			}else if(ant.getAntName() == AntNameEnum.ANT2) {
	        				cbAnt2.setSelected(ant.isEnable());
	        			}else if(ant.getAntName() == AntNameEnum.ANT3) {
	        				cbAnt3.setSelected(ant.isEnable());
	        			}else if(ant.getAntName() == AntNameEnum.ANT4) {
	        				cbAnt4.setSelected(ant.isEnable());
	        			}
	        		}
	        		
	        		JOptionPane.showConfirmDialog(ConfigContainer.this, "success",
							UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
	        	}else {
					JOptionPane.showConfirmDialog(ConfigContainer.this, "fail",
							UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
	        	}
	        }
	}
	
	private void setRelay() {
 
		int index = cmbRelay.getSelectedIndex();
		if (index>=0) {
		    int status = index;
            int ouput2 = 1; 
            int ouput1 = 1; 
        	SystemOut.println("setRelay  ouput1=" +ouput1+ "  ouput2=" + ouput2 +"   status="+status);
			if (((IUR4)UHFDemo.uhfReader).setIOControl((byte)ouput1,(byte)ouput2,(byte)status)) {
				JOptionPane.showConfirmDialog(ConfigContainer.this, "success",
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			} else {
				JOptionPane.showConfirmDialog(ConfigContainer.this, "fail",
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			}
		} else {
			JOptionPane.showConfirmDialog(ConfigContainer.this,"fail", UHFDemo.rs.getString("config"),
					JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		}
	 
	}
	
    private void getInput() {
    	byte[] inputStatus=((IUR4)UHFDemo.uhfReader).getIOControl();
    	if(inputStatus==null) {
    		JOptionPane.showConfirmDialog(ConfigContainer.this, "fail",
					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
    		return;
    	}
    	SystemOut.println("getInput  inputStatus[0]=" + inputStatus[0] + "inputStatus[1]=" + inputStatus[1]);
    	cmbInput1.setSelectedIndex(inputStatus[0]);
    	cmbInput2.setSelectedIndex(inputStatus[1]);
 
    	cmbInput2.updateUI();
    	cmbInput1.updateUI();
     
    }
	private void setAnt() {
	 
        if(UHFDemo.uhfReader instanceof IUR4) {
        	List<AntState> antInfo =new ArrayList<AntState>();
        	antInfo.add(new AntState(AntNameEnum.ANT1,cbAnt1.isSelected()));
        	antInfo.add(new AntState(AntNameEnum.ANT2,cbAnt2.isSelected()));
        	antInfo.add(new AntState(AntNameEnum.ANT3,cbAnt3.isSelected()));
        	antInfo.add(new AntState(AntNameEnum.ANT4,cbAnt4.isSelected()));
        	if(((IUR4)UHFDemo.uhfReader).setAnt(antInfo)) {
        		JOptionPane.showConfirmDialog(ConfigContainer.this, "success",
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
        	}else {
				JOptionPane.showConfirmDialog(ConfigContainer.this, "fail",
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
        	}
        }
		  
	}
	
	private void setPower() {
		String powerString = comboBoxPower.getSelectedItem().toString();
		if (StringUtils.isNotEmpty(powerString)) {
			if (UHFDemo.uhfReader.setPower(Integer.valueOf(powerString))) {
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_set_power_succ"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			} else {
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_set_power_fail"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			}
		} else {
			JOptionPane.showConfirmDialog(ConfigContainer.this,
					UHFDemo.rs.getString("msg_please_select_the_power_first"), UHFDemo.rs.getString("config"),
					JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		}
	}

	private void getPower(boolean showTips) {
		int power = UHFDemo.uhfReader.getPower();
		SystemOut.println("getPower=" + power);
		if (power > 0) {
			for (int i = 0; i < powerStrings.length; i++) {
				if (String.valueOf(power).equals(powerStrings[i])) {
					comboBoxPower.setSelectedIndex(i);
					break;
				}
			}
		} else {
			comboBoxPower.setSelectedIndex(0);
			if (showTips)
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_get_power_fail"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		}
		comboBoxPower.updateUI();
	}

	private void setFre() {
		String freString = comboBoxFre.getSelectedItem().toString();
		if (StringUtils.isNotEmpty(freString)) {
			if (UHFDemo.uhfReader.setFrequencyMode((byte) getMode(freString))) {
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_set_frequency_succ"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			} else {
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_set_frequency_fail"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			}
		} else {
			JOptionPane.showConfirmDialog(ConfigContainer.this,
					UHFDemo.rs.getString("msg_please_select_the_frequency_band_first"), UHFDemo.rs.getString("config"),
					JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		}
	}

	private void getFre(boolean showTips) {
		int fre = UHFDemo.uhfReader.getFrequencyMode();
		int index = getModeIndex(fre);
		SystemOut.println("getFre=" + fre + ", index=" + index);
		if (index > -1) {
			comboBoxFre.setSelectedIndex(index);
		} else {
			comboBoxFre.setSelectedIndex(0);
			if (showTips)
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_get_frequency_fail"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		}
		comboBoxFre.updateUI();
	}
	 
	 
	private int getMode(String modeName) {
		if (modeName.equals(UHFDemo.rs.getString("China1"))) {
			return 0x01;
		} else if (modeName.equals(UHFDemo.rs.getString("China2"))) {
			return 0x02;
		} else if (modeName.equals(UHFDemo.rs.getString("Europe"))) {
			return 0x04;
		} else if (modeName.equals(UHFDemo.rs.getString("USA"))) {
			return 0x08;
		} else if (modeName.equals(UHFDemo.rs.getString("Korea"))) {
			return 0x16;
		} else if (modeName.equals(UHFDemo.rs.getString("Japan"))) {
			return 0x32;
		} 
		return -1;
	}

	private String getModeName(int mode) {
		switch (mode) {
		case 0x01:
			return UHFDemo.rs.getString("China1");
		case 0x02:
			return UHFDemo.rs.getString("China2");
		case 0x04:
			return UHFDemo.rs.getString("Europe");
		case 0x08:
			return UHFDemo.rs.getString("USA");
		case 0x16:
			return UHFDemo.rs.getString("Korea");
		case 0x32:
			return UHFDemo.rs.getString("Japan");
		default:
			return null;
		}
	}

	private int getModeIndex(String modeName) {
		for (int i = 0; i < freStrings.length; i++) {
			if (freStrings[i].equals(modeName)) {
				return i;
			}
		}
		return -1;
	}

	private int getModeIndex(int mode) {
		return getModeIndex(getModeName(mode));
	}

	private void setProtocol() {
		int protocol = comboBoxProtocol.getSelectedIndex() - 1;
		if (protocol >= 0) {
			if (UHFDemo.uhfReader.setProtocol(protocol)) {
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_set_protocol_succ"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			} else {
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_set_protocol_fail"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			}
		} else {
			JOptionPane.showConfirmDialog(ConfigContainer.this,
					UHFDemo.rs.getString("msg_please_select_the_protocol_first"), UHFDemo.rs.getString("config"),
					JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		}
	}

	private void getProtocol(boolean showTips) {
		int protocol = UHFDemo.uhfReader.getProtocol();
		SystemOut.println("getProtocol=" + protocol);
		if (protocol >= 0) {
			comboBoxProtocol.setSelectedIndex(protocol + 1);
			if (showTips)
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_get_protocol_succ"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		} else {
			comboBoxProtocol.setSelectedIndex(0);
			if (showTips)
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_get_protocol_fail"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		}
		comboBoxProtocol.updateUI();
	}

	private void setBeep() {
		if (rdbtnOpen.isSelected()) {
			boolean res = UHFDemo.uhfReader.setBeep(1);
			if (res) {
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_open_beep_succ"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			} else {
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_open_beep_fail"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			}
		} else if (rdbtnClose.isSelected()) {
			boolean res = UHFDemo.uhfReader.setBeep(0);
			if (res) {
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_close_beep_succ"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			} else {
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_close_beep_fail"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			}
		} else {
			JOptionPane.showConfirmDialog(ConfigContainer.this,
					UHFDemo.rs.getString("msg_please_select_the_Open_or_Close_option_first"),
					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		}
	}

	private void getBeep(boolean showTips) {
		char[] res = UHFDemo.uhfReader.getBeep();
		if (res != null && res.length >= 2 && res[0] == 0) {
			if (res[1] == 0) {
				rdbtnClose.setSelected(true);
			} else if (res[1] == 1) {
				rdbtnOpen.setSelected(true);
			} else {
				if (showTips)
					JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_get_buzzer_fail"),
							UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			}
		} else {
			rdbtnOpen.setSelected(false);
			rdbtnClose.setSelected(false);
			if (showTips)
				JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_get_buzzer_fail"),
						UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		}
	}

	private void setIPAndPort() {
		String ip = textFieldIP.getText();
		String portString = textFieldPort.getText();
		if (StringUtils.isEmpty(ip)) {
			JOptionPane.showMessageDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_ip_cannot_be_null"),
					UHFDemo.rs.getString("config"), JOptionPane.ERROR_MESSAGE);
			return;
		} else if (!StringUtils.isIPAddress(ip)) {
			JOptionPane.showMessageDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_ip_is_incorrect"),
					UHFDemo.rs.getString("config"), JOptionPane.ERROR_MESSAGE);
			return;
		} else if (StringUtils.isEmpty(portString)) {
			JOptionPane.showMessageDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_port_cannot_be_null"),
					UHFDemo.rs.getString("config"), JOptionPane.ERROR_MESSAGE);
			return;
		} else if (StringUtils.toInt(portString, -1) < 0) {
			JOptionPane.showMessageDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_port_is_incorrect"),
					UHFDemo.rs.getString("config"), JOptionPane.ERROR_MESSAGE);
			return;
		}
		boolean res = UHFDemo.uhfReader.setIPAndPort(ip, portString);
		if (res) {
			JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_set_ip_port_succ"),
					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_set_ip_port_fail"),
					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		}
	}

	private void getIPAndPort(boolean showTips) {
		String[] ipAndPortArr = UHFDemo.uhfReader.getIPAndPort();
		if (ipAndPortArr != null) {
			textFieldIP.setText(ipAndPortArr[0]);
			textFieldPort.setText(ipAndPortArr[1]);
			if(showTips)
			JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_get_ip_port_succ"),
					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		} else {
			textFieldIP.setText("");
			textFieldPort.setText("");
			if(showTips)
			JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_get_ip_port_fail"),
					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		}
	}

	private void resetSoft() {
		boolean res = UHFDemo.uhfReader.resetUHFSoft();
		if (res) {
			onReset(0);
			JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_reset_succ"),
					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		} else {
			onReset(1);
			JOptionPane.showConfirmDialog(ConfigContainer.this, UHFDemo.rs.getString("msg_reset_fail"),
					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
		}
	}
	//--------------------
	private void setTriggerBeep() {
		try {
			String str=txtBeepDT.getText();
			System.out.println("setTriggerBeep  txtBeepDT="+str);
			if(str==null || str.isEmpty()) {
				JOptionPane.showConfirmDialog(ConfigContainer.this, "fail","fail", JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
				return;
			}
			int durationTime= Integer.parseInt(str);
		    RFIDWithUHFUsb usb= (RFIDWithUHFUsb)UHFDemo.uhfReader;
		    usb.triggerBeep(durationTime);
			
		}catch(Exception ex) {
			
		}
	}
	private void setBlinkOfLed() {
		System.out.println("setBlinkOfLed");
		String strCount=txtCount.getText();
		String strIt=txtIT.getText();
		String strDt=txtDT.getText();
		
		System.out.println("setBlinkOfLed  strCount="+strCount +"    strIt="+strIt   +"   strDt="+strDt);
		
		if(strCount==null || strCount.isEmpty()) {
			JOptionPane.showConfirmDialog(ConfigContainer.this, "fail","fail", JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			return;
		}
		if(strIt==null || strIt.isEmpty()) {
			JOptionPane.showConfirmDialog(ConfigContainer.this, "fail","fail", JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			return;
		}
		if(strDt==null || strDt.isEmpty()) {
			JOptionPane.showConfirmDialog(ConfigContainer.this, "fail","fail", JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
			return;
		}
		int durationTime=Integer.parseInt(strDt);;
	    int interval=Integer.parseInt(strIt);;
	    int count=Integer.parseInt(strCount);;
		RFIDWithUHFUsb usb= (RFIDWithUHFUsb)UHFDemo.uhfReader;
		usb.blinkOfLed(durationTime, interval, count) ;
	}
	 
	private void setLEDOff() {
	   System.out.println("setLED");
	   RFIDWithUHFUsb usb= (RFIDWithUHFUsb)UHFDemo.uhfReader;
	   usb.setLed(0);
	}
	private void setLEDOn() {
		   System.out.println("setLED");
		   RFIDWithUHFUsb usb= (RFIDWithUHFUsb)UHFDemo.uhfReader;
		   usb.setLed(1);
		}
	//---------------------
	
	
	private long mSleepTime = 0;
	private Runnable getConfigRunnable = new Runnable() {
		
		@Override
		public void run() {
			// TODO Auto-generated method stub
			try {
				if(mSleepTime > 0) {
					Thread.sleep(mSleepTime);
				}
				getPower(false);
				getFre(false);
				getProtocol(false);
				getBeep(false);
				getIPAndPort(false);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	};
	
	/**
	 * 获取参数
	 * @param sleepTime
	 */
	public void getConfigParams(long sleepTime) {
		mSleepTime = sleepTime;
		UHFDemo.mExecutorService.execute(getConfigRunnable);
	}

	@Override
	protected boolean isPrivate() {
		// TODO Auto-generated method stub
		return true;
	}

	private void onReset(int status) {
		if (resetListeners != null) {
			for (ResetSoftListener listener : resetListeners) {
				if (status == 0) {
					listener.onResetSucc();
				} else if (status == 1) {
					listener.onResetFail();
				}
			}
		}
	}

	private List<ResetSoftListener> resetListeners = new ArrayList<ResetSoftListener>();

	public void addResetSoftListener(ResetSoftListener resetSoftListener) {
		resetListeners.add(resetSoftListener);
	}

	public void removeResetSoftListener(ResetSoftListener resetSoftListener) {
		resetListeners.remove(resetSoftListener);
	}

	public void clearResetSoftListener() {
		resetListeners.clear();
		resetListeners = null;
	}

	public interface ResetSoftListener {
		void onResetSucc();

		void onResetFail();
	}
}
 
