package com.cw.uhf.container;

import java.awt.Button;
import java.awt.Font;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.Arrays;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JProgressBar;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileSystemView;

import com.cw.uhf.UHFDemo;
import com.cw.uhf.util.StringUtils;
 

public class FirmwareUpgradeContainer extends BaseContainer{
	JLabel jlPath ;
	JTextField textField ;
	JProgressBar pgbar;
	Button btnSelect;
	Button btn;
	@Override
	public void updateLanguageUI() {
		// TODO Auto-generated method stub
		super.updateLanguageUI();
		 
	}
	public void setBtnsEnabled(boolean enabled) {
		btnSelect.setEnabled(enabled);
	}
	public FirmwareUpgradeContainer() {
		super();
		init();
	}
	private void init() {
		setBackground(UIManager.getColor("Button.highlight"));
		setBounds(12, 86, 1060, 690);
		setLayout(null);
	    jlPath = new JLabel("path:");
		jlPath.setFont(new Font("Dialog", Font.BOLD, 18));
		jlPath.setBounds(114, 100, 150, 25);
		
	    textField = new JTextField(18);
		textField.setFont(new Font("Dialog",Font.ITALIC,16));
		textField.setBounds(180, 100, 580, 25);
		
	    btnSelect=new Button("选择文件");
		btnSelect.setName("File");
		btnSelect.setFont(new Font("Dialog",Font.BOLD,16));
		btnSelect.setBounds(780, 100, 150, 30);
		
	    btn=new Button("升级");
		btn.setName("File");
		btn.setFont(new Font("Dialog",Font.BOLD,16));
		btn.setBounds(180, 150, 150, 60);
		
	    pgbar=new JProgressBar(0,100);
		pgbar.setBounds(180, 260, 500, 20);
		add(jlPath);
		add(textField);
		add(btn);
		add(btnSelect);
		add(pgbar);
	 
		btn.addMouseListener(new MyMouseListener() {
			@Override
			public void mouseClicked(MouseEvent e) {
				 //创建一个最小值是0，最大值是100的进度条
			      pgbar.setValue(0);
				
			       String filePath = textField.getText().toString();
	                if (StringUtils.isEmpty(filePath)) {
	                	JOptionPane.showConfirmDialog(FirmwareUpgradeContainer.this, "fail","fail", JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
	                    return;
	                }
	                if (filePath.toLowerCase().lastIndexOf(".bin") < 0) {
	                	JOptionPane.showConfirmDialog(FirmwareUpgradeContainer.this, "fail","fail", JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
	                    return;
	                }
	              btn.setEnabled(false);
				  new Progress(pgbar,filePath).start();
				 
			}});
		
		btnSelect.addMouseListener(new MyMouseListener() {
			@Override
			public void mouseClicked(MouseEvent e) {
			    JFileChooser chooser = new JFileChooser(new File("/"));//FileSystemView.getFileSystemView().getDefaultDirectory()
			   // chooser.setFileFilter(new BinFilter());
		        int returnValue = chooser.showOpenDialog(null);
		      
		        if (returnValue == JFileChooser.APPROVE_OPTION) {
		            File selectedFile = chooser.getSelectedFile();
		            textField.setText(selectedFile.getAbsolutePath());
		        }
			}});
	 
	}

	@Override
	protected boolean isPrivate() {
		// TODO Auto-generated method stub
		return true;
	}

	private class Progress extends Thread
    {
        JProgressBar progressBar;
        String mFileName;
        boolean isR2000=true;
        Progress(JProgressBar progressBar,String path)
        {
            this.progressBar=progressBar;
            this.mFileName=path;
        }
        public void run()
        {
        	try {
        	   // TODO Auto-generated method stub
            boolean result = false;
            File uFile = new File(mFileName);
            if (!uFile.exists()) {
               System.out.println("fail");
       		  JOptionPane.showConfirmDialog(FirmwareUpgradeContainer.this, "fail",
					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
                return;
            }
            long uFileSize = uFile.length();
            System.out.println("uFileSize=" + uFileSize);
            int packageCount = (int) (uFileSize / 64);
            System.out.println( "packageCount=" + packageCount);
            
            RandomAccessFile raf = null;
            try {
                raf = new RandomAccessFile(mFileName, "r");
            } catch (FileNotFoundException e) {
            }
            if (raf == null) {
                System.out.println("fail");
      		  JOptionPane.showConfirmDialog(FirmwareUpgradeContainer.this, "fail",
  					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
                return;
            }
            if(uFileSize>1024*200) {
            	isR2000=true;
                String version = UHFDemo.uhfReader.getVersion();//获取版本号
                System.out.println("UHF version="+version);
                System.out.println("UHF uhfJump2Boot begin");
                if (!UHFDemo.uhfReader.uhfJump2Boot()) {
                	System.out.println( "1111111111111111111");
                	// System.out.println( "uhfJump2Boot 失败");
                    //return;
                }
            }else {
             	isR2000=false;
                System.out.println("UHF uhfJump2BootToSTM32 begin");
                if (!UHFDemo.uhfReader.uhfJump2BootToSTM32()) {
                	System.out.println( "22222222222222222");
                }
            }

       
            sleep(2000);
            System.out.println("UHF uhfStartUpdate begin");
            if (!UHFDemo.uhfReader.uhfStartUpdate()) {
                System.out.println( "uhfStartUpdate 失败");
      		  JOptionPane.showConfirmDialog(FirmwareUpgradeContainer.this, "fail",
  					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
                return;
            }
            sleep(2000);
            int pakeSize = 64;
            byte[] currData = new byte[(int) uFileSize];
            for (int k = 0; k < packageCount; k++) {
                int index = k * pakeSize;
                try {
                    int rsize = raf.read(currData, index, pakeSize);
                   // System.out.println( "beginPack=" + index + " endPack=" + (index + pakeSize - 1) + " rsize=" + rsize);
                } catch (IOException e) {
                	stopUpgrader();
                    System.out.println( "失败!");
          		  JOptionPane.showConfirmDialog(FirmwareUpgradeContainer.this, "fail",
      					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
                    return;
                }

                if (UHFDemo.uhfReader.uhfUpdating(Arrays.copyOfRange(currData, index, index + pakeSize))) {
                    result = true;
                    setprogressValue(index + pakeSize, (int) uFileSize);
                    //sleep(10);
                } else {
                	 System.out.println("uhfUpdating 失败");
                	 stopUpgrader();
           		  JOptionPane.showConfirmDialog(FirmwareUpgradeContainer.this, "fail",
      					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
                    return;
                }

            }
            if (uFileSize % pakeSize != 0) {
                int index = packageCount * pakeSize;
                int len = (int) (uFileSize % pakeSize);
                try {
                    int rsize = raf.read(currData, index, len);
               	    System.out.println("beginPack=" + index + " countPack=" + len + " rsize=" + rsize);
                } catch (IOException e) {
                	 System.out.println("IOException ");
                	 stopUpgrader();
           		  JOptionPane.showConfirmDialog(FirmwareUpgradeContainer.this, "fail",
      					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
                     return;
                }
                if (UHFDemo.uhfReader.uhfUpdating(Arrays.copyOfRange(currData, index, index + len))) {
                    result = true;
                    setprogressValue((int) uFileSize, (int) uFileSize);
          		  JOptionPane.showConfirmDialog(FirmwareUpgradeContainer.this, "success",
      					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
                } else {
               	    System.out.println("uhfUpdating 失败");
               	 stopUpgrader();
       		  JOptionPane.showConfirmDialog(FirmwareUpgradeContainer.this, "fail",
  					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
                    return;
                }
            }
            stopUpgrader();
            //success 
            JOptionPane.showConfirmDialog(FirmwareUpgradeContainer.this, "success",
  					UHFDemo.rs.getString("config"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
            progressBar.setIndeterminate(false); 
        	}catch(Exception ex) {
        		
        	}finally{
        		btn.setEnabled(true);
        	}
        }
        private void sleep(int time) {
            try {
                Thread.sleep(time);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        private void setprogressValue(int value,int total) {
            //设置进度条的值
            progressBar.setValue(value*100/total);
        }
        private void stopUpgrader() {
            if (!UHFDemo.uhfReader.uhfStopUpdate()) {
               // System.out.println("uhfStopUpdate 失败");
            }
            sleep(2000);
        }
    }

 
	class MyMouseListener implements MouseListener{

		@Override
		public void mouseClicked(MouseEvent e) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void mousePressed(MouseEvent e) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void mouseReleased(MouseEvent e) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void mouseEntered(MouseEvent e) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void mouseExited(MouseEvent e) {
			// TODO Auto-generated method stub
			
		}
		
	}
	class BinFilter extends FileFilter
    {
 
        public boolean accept(File f)
        {
            if (f.isDirectory())
            {
                return true;
            }
 
            String extension =   f.getPath().substring(f.getPath().lastIndexOf("."));
            if (extension != null)
            {
                if (extension.equals("bin"))
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            return false;
        }
 
        public String getDescription()
        {
            return "*.bin";
        }
    }
}
