package com.cw.uhf.container;

import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.JTableHeader;

import com.cw.uhf.UHFDemo;
import com.cw.uhf.model.InventoryTableModel;
import com.cw.uhf.util.NumberTool;
import com.cw.uhf.util.StringUtils;
 
import com.rscja.deviceapi.entity.UHFTAGInfo;
import javax.swing.ListSelectionModel;

public class InventoryContainer extends BaseContainer {
	private boolean loopReadFlag;
	
	private JLabel numberLabel, totalLabel, timeLabel, idleLabel;
	private JButton buttonStart, buttonClear;
	private JScrollBar jScrollBar;
	private JTable jTable;
	private InventoryTableModel inventoryTableModel;
	private List<UHFTAGInfo> uhftagInfoList = new ArrayList<UHFTAGInfo>();
	
	private JLabel labelTagCount;
	private JLabel labelTotalCount;
	private JLabel labelTime;
	
	private int totalCount;
	private float totalTime;
	private long startReadTime;
 
	private MouseAdapter mouseAdapter = new MouseAdapter() {
		public void mouseClicked(MouseEvent e) {
			if(!e.getComponent().isEnabled()) {
				return;
			}
			if(e.getComponent() == buttonStart) {
				if (buttonStart.getText().equals(UHFDemo.rs.getString("start"))) {
					if (UHFDemo.uhfReader.startInventoryTag()) {
						
						if(inventoryListener != null) {
							inventoryListener.onStart();
						}
						
						setFilterBtnsEnabled(false);
						buttonStart.setText(UHFDemo.rs.getString("stop"));
						loopReadFlag = true;
						startReadTime = System.currentTimeMillis();

						 read();
					} else {
						JOptionPane.showMessageDialog(InventoryContainer.this, UHFDemo.rs.getString("msg_start_inventory_fail"), UHFDemo.rs.getString("inventory"), JOptionPane.ERROR_MESSAGE);
					}
				} else {
					stopInventory();
				}
			} else if (e.getComponent() == buttonClear) {
 
				clear();
			}
		};
	};
	
	public InventoryContainer() {
		super();
//		textFieldStartAddress.setLocation(330, 10);
//		startAddressLabel.setSize(98, 25);
		init();
	}

	private void init() {
		setBackground(UIManager.getColor("Button.highlight"));
		setBounds(12, 102, 1060, 690);
		setLayout(null);

		JPanel panel_1 = new JPanel();
		panel_1.setBounds(0, 81, 1060, 562);
		panel_1.setLayout(null);
		add(panel_1);

		inventoryTableModel = new InventoryTableModel(uhftagInfoList);
		jTable = new JTable(inventoryTableModel);
		jTable.setFillsViewportHeight(true);
		jTable.getTableHeader().setFont(new Font("楷体", Font.BOLD, 14));// 设置表头字体
		jTable.setFont(new Font("楷体", Font.BOLD, 13));
		jTable.setBackground(UIManager.getColor("List.background"));
		jTable.setBounds(0, 27, 776, 320);
		jTable.setShowGrid(false);
//		jTable.setShowVerticalLines(true);
//		jTable.setShowHorizontalLines(true);
//		jTable.setRowMargin(12);
		jTable.setRowHeight(jTable.getRowHeight() + 12); // 行高
		jTable.getColumn(jTable.getColumnName(1)).setPreferredWidth(200); // EPC列宽
		jTable.getColumn(jTable.getColumnName(2)).setPreferredWidth(200); // TID列宽

		DefaultTableCellRenderer renderer = new DefaultTableCellRenderer();
		renderer.setHorizontalAlignment(JTextField.CENTER);
//		jTable.setDefaultRenderer(Object.class, renderer); // 所有内容都居中
		jTable.getColumn(jTable.getColumnName(0)).setCellRenderer(renderer);
		jTable.getColumn(jTable.getColumnName(3)).setCellRenderer(renderer);
		jTable.getColumn(jTable.getColumnName(4)).setCellRenderer(renderer);
		jTable.getColumn(jTable.getColumnName(5)).setCellRenderer(renderer);

		JScrollPane scrollPane = new JScrollPane(jTable);
		scrollPane.setBounds(0, 0, 1060, 560);
		panel_1.add(scrollPane);
		
		jScrollBar = scrollPane.getVerticalScrollBar(); //得到了该JScrollBar

		JPanel panel_2 = new JPanel();
		panel_2.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		panel_2.setBounds(0, 641, 1060, 49);
		panel_2.setLayout(null);
		add(panel_2);

		numberLabel = new JLabel("标签数：");
		numberLabel.setFont(new Font("Dialog", Font.BOLD, 13));
		numberLabel.setBounds(12, 12, 80, 25);
		panel_2.add(numberLabel);

		labelTagCount = new JLabel("0");
		labelTagCount.setFont(new Font("Dialog", Font.BOLD, 18));
		labelTagCount.setBounds(95, 12, 90, 25);
		panel_2.add(labelTagCount);

		totalLabel = new JLabel("次数：");
		totalLabel.setFont(new Font("Dialog", Font.BOLD, 13));
		totalLabel.setBounds(195, 12, 80, 25);
		panel_2.add(totalLabel);

		labelTotalCount = new JLabel("0");
		labelTotalCount.setFont(new Font("Dialog", Font.BOLD, 18));
		labelTotalCount.setBounds(280, 12, 100, 25);
		panel_2.add(labelTotalCount);

		timeLabel = new JLabel("时间：");
		timeLabel.setFont(new Font("Dialog", Font.BOLD, 13));
		timeLabel.setBounds(390, 12, 60, 25);
		panel_2.add(timeLabel);

		labelTime = new JLabel("0 s");
		labelTime.setFont(new Font("Dialog", Font.BOLD, 18));
		labelTime.setBounds(455, 12, 110, 25);
		panel_2.add(labelTime);

		buttonStart = new JButton("开始");
		buttonStart.setEnabled(false);
		buttonStart.setBounds(580, 7, 90, 35);
		buttonStart.addMouseListener(mouseAdapter);
		panel_2.add(buttonStart);

		buttonClear = new JButton("清空");
		buttonClear.setEnabled(false);
		buttonClear.setBounds(690, 7, 90, 35);
		buttonClear.addMouseListener(mouseAdapter);
		panel_2.add(buttonClear);
	 
	}
	
	@Override
	public void setVisible(boolean aFlag) {
		// TODO Auto-generated method stub
		super.setVisible(aFlag);
		if(!aFlag) {
			stopInventory();
		}
	}
	
	public void setBtnsEnabled(boolean enabled) {
		buttonStart.setEnabled(enabled);
		buttonClear.setEnabled(enabled);
		setFilterBtnsEnabled(enabled);
	}
	
	private void setFilterBtnsEnabled(boolean enabled) {
		buttonSet.setEnabled(enabled);
		buttonReset.setEnabled(enabled);
	}
	
	@Override
	public void updateLanguageUI() {
		// TODO Auto-generated method stub
		super.updateLanguageUI();
		numberLabel.setText(UHFDemo.rs.getString("numberOfTags"));
		totalLabel.setText(UHFDemo.rs.getString("times"));
		timeLabel.setText(UHFDemo.rs.getString("time"));
		
		if(loopReadFlag) {
			buttonStart.setText(UHFDemo.rs.getString("stop"));
		} else {
			buttonStart.setText(UHFDemo.rs.getString("start"));
		}
		buttonClear.setText(UHFDemo.rs.getString("clear"));
	}

	private void read() {
		new Thread() {
			public void run() {
				while (loopReadFlag) {
					UHFTAGInfo uhftagInfo = UHFDemo.uhfReader.readTagFromBuffer();
					if (uhftagInfo != null) {
//						System.out.println("epc=" + uhftagInfo.getEPC());
						int index = checkIsExist(uhftagInfoList, uhftagInfo.getEPC());
						if(index < 0) {
							uhftagInfoList.add(uhftagInfo);
						}
						totalCount++;
						inventoryTableModel.putTagCount(uhftagInfo.getEPC());
					}else {
						try {
							Thread.sleep(5);
						} catch (InterruptedException e) {

						}
					}
				 
					totalTime = (System.currentTimeMillis() - startReadTime) / 1000f;  
					invokeAndWaitUpdateDataUI();
				}
			};
		}.start();
	}
	
	private void updateDataUI() {
		labelTagCount.setText(String.valueOf(uhftagInfoList.size()));
		labelTotalCount.setText(String.valueOf(totalCount));
		labelTime.setText(NumberTool.getPointDouble(1, totalTime) + " s");
		jTable.updateUI();
		 
 
	}
	
	public boolean isStartInventory() {
		return loopReadFlag;
	}
	
	private Runnable updateUIRunnable = new Runnable() {
		
		@Override
		public void run() {
			// TODO Auto-generated method stub
			updateDataUI();
//			jScrollBar.setValue(jScrollBar.getMaximum());  //设置一个具体位置，value为具体的位置 
		}
	};
	
	private void invokeAndWaitUpdateDataUI() {
		try {
			EventQueue.invokeAndWait(updateUIRunnable);
//			SwingUtilities.invokeLater(updateUIRunnable);
		} catch (InvocationTargetException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/**
	 * 停止盘点
	 */
	public void stopInventory() {
		if(loopReadFlag) {
			loopReadFlag = false;
			UHFDemo.uhfReader.stopInventory();
		}
		buttonStart.setText(UHFDemo.rs.getString("start"));
		
		if(inventoryListener != null) {
			inventoryListener.onStop();
		}
		setFilterBtnsEnabled(true);
	}

	private void clear() {
		inventoryTableModel.clear();
		uhftagInfoList.clear();
		totalCount = 0;
		totalTime = 0;
		updateDataUI();
	
	 
		 
	}

    /**
     * 判断EPC是否在列表中
     *
     * @param epc 索引
     * @return
     */
    public int checkIsExist(List<UHFTAGInfo> uhftagInfoList, String epc) {
        int existFlag = -1;
        if (StringUtils.isEmpty(epc)) {
            return existFlag;
        }
        return binarySerach(uhftagInfoList, epc);
    }
	
	/**
     * 二分查找，找到该值在数组中的下标，否则为-1
     */
    private int binarySerach(List<UHFTAGInfo> array, String src) {
    	if(array == null) {
    		return -1;
    	}
        int left = 0;
        int right = array.size() - 1;
        // 这里必须是 <=
        while (left <= right) {
            if (compareString(array.get(left).getEPC(), src)) {
                return left;
            } else if (left != right) {
                if (compareString(array.get(right).getEPC(), src))
                    return right;
            }
            left++;
            right--;
        }
        return -1;
    }

    private boolean compareString(String str1, String str2) {
    	if(StringUtils.isEmpty(str1) || StringUtils.isEmpty(str2)) {
    		return false;
    	} else if (str1.length() != str2.length()) {
            return false;
        } else if (str1.hashCode() != str2.hashCode()) {
            return false;
        } else {
            char[] value1 = str1.toCharArray();
            char[] value2 = str2.toCharArray();
            int size = value1.length;
            for (int k = 0; k < size; k++) {
                if (value1[k] != value2[k]) {
                    return false;
                }
                k++;
            }
            return true;
        }
    }
    
    private InventoryListener inventoryListener;
    
    public void setInventoryListener(InventoryListener inventoryListener) {
		this.inventoryListener = inventoryListener;
	}
    public interface InventoryListener {
		void onStart();
		void onStop();
	}
}
