package com.cw.uhf.container;

import java.awt.Color;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import com.cw.uhf.UHFDemo;
import com.cw.uhf.util.StringUtils;
import com.rscja.deviceapi.RFIDWithUHFUART;


public class LockKillContainer extends BaseContainer {
	
	private JTextField textFieldPwdLock;
	private JTextField textFieldPwdKill;
	
	private JRadioButton rdbtnOpen;
	private JRadioButton rdbtnLock;
	private JRadioButton rdbtnForeverOpen;
	private JRadioButton rdbtnForeverLock;
	private JRadioButton rdbtnKillPwd;
	private JRadioButton rdbtnAccesspwd;
	private JRadioButton rdbtnEpcLock;
	private JRadioButton rdbtnTidLock;
	private JRadioButton rdbtnUserLock;
	
	private JLabel labelPwdLock, labelPwdTipsLock, labelPwdKill, labelPwdTipsKill;
	
	private int lockModeEnum;
	private ArrayList<Integer> lockBankEnums = new ArrayList<Integer>();
	private JLabel labelLockCode;
	
	private JButton btnOk, btnKillTag;
	private MouseAdapter mouseAdapter = new MouseAdapter() {
		public void mouseClicked(MouseEvent e) {
			if(!e.getComponent().isEnabled()) {
				return;
			}
			if(e.getComponent() == btnOk) {
				lock();
			} else if (e.getComponent() == btnKillTag) {
				kill();
			}
		};
	};

	private ChangeListener lockChangeListener = new ChangeListener() {
		
		@Override
		public void stateChanged(ChangeEvent e) {
			// TODO Auto-generated method stub
			setLockCode();
		}
	};
	
	public LockKillContainer() {
		super();
		init();
	}
	
	private void init() {
		setBackground(UIManager.getColor("Button.highlight"));
		setBounds(12, 102, 1060, 690);
		setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBounds(0, 82, 1060, 692);
		add(panel);
		panel.setLayout(null);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		panel_1.setBounds(0, 0, 525, 184);
		panel.add(panel_1);
		panel_1.setLayout(null);
		
		JPanel panel_3 = new JPanel();
		panel_3.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		panel_3.setBounds(0, 0, 525, 47);
		panel_1.add(panel_3);
		panel_3.setLayout(null);
		
		textFieldPwdLock = new JTextField();
		textFieldPwdLock.setBounds(134, 10, 120, 29);
		panel_3.add(textFieldPwdLock);
		textFieldPwdLock.setColumns(10);
		
		labelPwdTipsLock = new JLabel("不能使用默认密码");
		labelPwdTipsLock.setForeground(Color.RED);
		labelPwdTipsLock.setBounds(260, 12, 250, 25);
		panel_3.add(labelPwdTipsLock);
		
		labelPwdLock = new JLabel("访问密码：", JLabel.CENTER);
		labelPwdLock.setBounds(12, 12, 120, 25);
		panel_3.add(labelPwdLock);
		
		JPanel panel_4 = new JPanel();
		panel_4.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		panel_4.setBounds(0, 47, 525, 47);
		panel_1.add(panel_4);
		panel_4.setLayout(null);
		
		ButtonGroup buttonGroup = new ButtonGroup();
		
		rdbtnOpen = new JRadioButton("开放");
		rdbtnOpen.setSelected(true); // default select the Open option
		rdbtnOpen.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		rdbtnOpen.setBounds(8, 8, 80, 33);
		panel_4.add(rdbtnOpen);
		buttonGroup.add(rdbtnOpen);
		rdbtnOpen.addChangeListener(lockChangeListener);
		
		rdbtnLock = new JRadioButton("锁定");
		rdbtnLock.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		rdbtnLock.setBounds(90, 8, 80, 33);
		panel_4.add(rdbtnLock);
		buttonGroup.add(rdbtnLock);
		rdbtnLock.addChangeListener(lockChangeListener);
		
		rdbtnForeverOpen = new JRadioButton("永久开放");
		rdbtnForeverOpen.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		rdbtnForeverOpen.setBounds(180, 8, 150, 33);
		panel_4.add(rdbtnForeverOpen);
		buttonGroup.add(rdbtnForeverOpen);
		rdbtnForeverOpen.addChangeListener(lockChangeListener);
		
		rdbtnForeverLock = new JRadioButton("永久锁定");
		rdbtnForeverLock.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		rdbtnForeverLock.setBounds(335, 8, 150, 33);
		panel_4.add(rdbtnForeverLock);
		buttonGroup.add(rdbtnForeverLock);
		rdbtnForeverLock.addChangeListener(lockChangeListener);
		
		JPanel panel_5 = new JPanel();
		panel_5.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		panel_5.setBounds(0, 92, 525, 47);
		panel_1.add(panel_5);
		panel_5.setLayout(null);
		
		ButtonGroup buttonGroup2 = new ButtonGroup();
		
		rdbtnKillPwd = new JRadioButton("Kill-pwd");
		rdbtnKillPwd.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		rdbtnKillPwd.setBounds(8, 8, 82, 33);
		panel_5.add(rdbtnKillPwd);
		buttonGroup2.add(rdbtnKillPwd);
		rdbtnKillPwd.addChangeListener(lockChangeListener);
		
		rdbtnAccesspwd = new JRadioButton("Access-pwd");
		rdbtnAccesspwd.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		rdbtnAccesspwd.setBounds(94, 8, 120, 33);
		panel_5.add(rdbtnAccesspwd);
		buttonGroup2.add(rdbtnAccesspwd);
		rdbtnAccesspwd.addChangeListener(lockChangeListener);
		
		rdbtnEpcLock = new JRadioButton("EPC");
		rdbtnEpcLock.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		rdbtnEpcLock.setBounds(220, 8, 60, 33);
		panel_5.add(rdbtnEpcLock);
		buttonGroup2.add(rdbtnEpcLock);
		rdbtnEpcLock.addChangeListener(lockChangeListener);
		
		rdbtnTidLock = new JRadioButton("TID");
		rdbtnTidLock.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		rdbtnTidLock.setBounds(290, 8, 50, 33);
		panel_5.add(rdbtnTidLock);
		buttonGroup2.add(rdbtnTidLock);
		rdbtnTidLock.addChangeListener(lockChangeListener);
		
		rdbtnUserLock = new JRadioButton("USER");
		rdbtnUserLock.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		rdbtnUserLock.setBounds(350, 8, 80, 33);
		panel_5.add(rdbtnUserLock);
		buttonGroup2.add(rdbtnUserLock);
		rdbtnUserLock.addChangeListener(lockChangeListener);
		
		JPanel panel_6 = new JPanel();
		panel_6.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		panel_6.setBounds(0, 137, 525, 47);
		panel_1.add(panel_6);
		panel_6.setLayout(null);
		
		JLabel lblLockcode = new JLabel("LockCode:");
		lblLockcode.setBounds(12, 12, 80, 25);
		panel_6.add(lblLockcode);
		
		labelLockCode = new JLabel("");
		labelLockCode.setForeground(new Color(255, 0, 255));
		labelLockCode.setBounds(95, 12, 80, 25);
		panel_6.add(labelLockCode);
		
		btnOk = new JButton("确定");
		btnOk.setEnabled(false);
		btnOk.setBounds(190, 7, 90, 35);
		panel_6.add(btnOk);
		btnOk.addMouseListener(mouseAdapter);
		
		JPanel panel_2 = new JPanel();
		panel_2.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		panel_2.setBounds(537, 0, 523, 184);
		panel.add(panel_2);
		panel_2.setLayout(null);
		
		JPanel panel_7 = new JPanel();
		panel_7.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		panel_7.setBounds(0, 0, 523, 49);
		panel_2.add(panel_7);
		panel_7.setLayout(null);
		
		labelPwdKill = new JLabel("访问密码：", JLabel.CENTER);
		labelPwdKill.setBounds(12, 14, 120, 25);
		panel_7.add(labelPwdKill);
		
		textFieldPwdKill = new JTextField();
		textFieldPwdKill.setColumns(10);
		textFieldPwdKill.setBounds(134, 12, 120, 29);
		panel_7.add(textFieldPwdKill);
		
		labelPwdTipsKill = new JLabel("不能使用默认密码");
		labelPwdTipsKill.setForeground(Color.RED);
		labelPwdTipsKill.setBounds(260, 14, 250, 25);
		panel_7.add(labelPwdTipsKill);
		
		btnKillTag = new JButton("销毁标签");
		btnKillTag.setEnabled(false);
		btnKillTag.setBounds(150, 61, 90, 35);
		panel_2.add(btnKillTag);
		btnKillTag.addMouseListener(mouseAdapter);
	}
	
	public void setBtnsEnabled(boolean enabled) {
		if(buttonSet != null)
			buttonSet.setEnabled(enabled);
		if(buttonReset != null)
			buttonReset.setEnabled(enabled);
		
		btnOk.setEnabled(enabled);
		btnKillTag.setEnabled(enabled);
	}
	
	@Override
	public void updateLanguageUI() {
		// TODO Auto-generated method stub
		super.updateLanguageUI();
		
		labelPwdLock.setText(UHFDemo.rs.getString("accessPwd"));
		labelPwdKill.setText(UHFDemo.rs.getString("accessPwd"));
		labelPwdTipsLock.setText(UHFDemo.rs.getString("pwdTips"));
		labelPwdTipsKill.setText(UHFDemo.rs.getString("pwdTips"));
		
		rdbtnOpen.setText(UHFDemo.rs.getString("openUp"));
		rdbtnLock.setText(UHFDemo.rs.getString("lock"));
		rdbtnForeverOpen.setText(UHFDemo.rs.getString("pOpen"));
		rdbtnForeverLock.setText(UHFDemo.rs.getString("pLock"));
		
		btnOk.setText(UHFDemo.rs.getString("ok"));
		btnKillTag.setText(UHFDemo.rs.getString("killTag"));
	}
	
	private void setLockCode() {
		if(rdbtnOpen.isSelected()) {
            lockModeEnum = RFIDWithUHFUART.LockMode_OPEN;
		} else if (rdbtnLock.isSelected()) {
            lockModeEnum = RFIDWithUHFUART.LockMode_LOCK;
		} else if (rdbtnForeverOpen.isSelected()) {
            lockModeEnum = RFIDWithUHFUART.LockMode_POPEN;
		} else if (rdbtnForeverLock.isSelected()) {
            lockModeEnum = RFIDWithUHFUART.LockMode_PLOCK;
		}

		lockBankEnums.clear();
        if(rdbtnKillPwd.isSelected()) {
            lockBankEnums.add(RFIDWithUHFUART.LockBank_KILL);
        }
        if(rdbtnAccesspwd.isSelected()) {
            lockBankEnums.add(RFIDWithUHFUART.LockBank_ACCESS);
        }
        if(rdbtnEpcLock.isSelected()) {
            lockBankEnums.add(RFIDWithUHFUART.LockBank_EPC);
        }
        if(rdbtnTidLock.isSelected()) {
            lockBankEnums.add(RFIDWithUHFUART.LockBank_TID);
        }
        if(rdbtnUserLock.isSelected()) {
            lockBankEnums.add(RFIDWithUHFUART.LockBank_USER);
        }
        labelLockCode.setText(UHFDemo.uhfReader.generateLockCode(lockBankEnums, lockModeEnum));
	}
	
	private void lock() {
		String strPWD = textFieldPwdLock.getText();
		if (StringUtils.isNotEmpty(strPWD)) {
            if (strPWD.length() != 8) {
			    JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_password_must_be_8_bits"), UHFDemo.rs.getString("lock"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
                return;
            } else if (!StringUtils.isHex(strPWD)) {
				JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_password_must_be_hexadecimal"), UHFDemo.rs.getString("lock"), JOptionPane.CLOSED_OPTION,
						JOptionPane.INFORMATION_MESSAGE);
                return;
            }
        } else {
			JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_password_connot_be_empty"), UHFDemo.rs.getString("lock"), JOptionPane.CLOSED_OPTION,
					JOptionPane.INFORMATION_MESSAGE);
            return;
        }
		
		String strLockCode = labelLockCode.getText();
        if (!StringUtils.isNotEmpty(strLockCode)) {
			JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_lock_code_cannot_be_empty"), UHFDemo.rs.getString("lock"), JOptionPane.CLOSED_OPTION,
					JOptionPane.INFORMATION_MESSAGE);
            return;
        }

		int filterPtr = StringUtils.toInt(textFieldStartAddress.getText(), -1);
		int filterCnt = StringUtils.toInt(textFieldLength.getText(), -1);
		String filterData = textFieldData.getText();
		int filterBank = RFIDWithUHFUART.Bank_EPC;

        boolean res;
		if (filterCnt > 0 && StringUtils.isNotEmpty(filterData)) { // 过滤
            //----------------过滤----------------------------
        	if (filterPtr < 0) {
				JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_filter_start_address_must_be_decimal"), UHFDemo.rs.getString("lock"),
						JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
				return;
			}
			int flag = filterCnt / 8 + (filterCnt % 8 == 0 ? 0 : 1);
			int dataLen = filterData.replace(" ", "").length() / 2;
			if (dataLen < flag) {
				JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_filter_length_error"), UHFDemo.rs.getString("lock"), JOptionPane.CLOSED_OPTION,
						JOptionPane.INFORMATION_MESSAGE);
				return;
			}

			if (rdbtnEpc.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_EPC;
			} else if (rdbtnTid.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_TID;
			} else if (rdbtnUser.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_USER;
			}
            res = UHFDemo.uhfReader.lockMem(strPWD, filterBank, filterPtr, filterCnt, filterData, strLockCode);
		} else {
            res = UHFDemo.uhfReader.lockMem(strPWD, strLockCode);
		}
		
        if(res) {
			JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_lock_succ"), UHFDemo.rs.getString("lock"), JOptionPane.CLOSED_OPTION,
					JOptionPane.INFORMATION_MESSAGE);
        } else {
			JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_lock_fail"), UHFDemo.rs.getString("lock"), JOptionPane.CLOSED_OPTION,
					JOptionPane.INFORMATION_MESSAGE);
        }
	}
	
	private void kill() {
		String strPWD = textFieldPwdKill.getText();
		if (StringUtils.isNotEmpty(strPWD)) {
            if (strPWD.length() != 8) {
			    JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_password_must_be_8_bits"), UHFDemo.rs.getString("kill"), JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
                return;
            } else if (!StringUtils.isHex(strPWD)) {
				JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_password_must_be_hexadecimal"), UHFDemo.rs.getString("kill"), JOptionPane.CLOSED_OPTION,
						JOptionPane.INFORMATION_MESSAGE);
                return;
            }
        } else {
			JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_password_connot_be_empty"), UHFDemo.rs.getString("kill"), JOptionPane.CLOSED_OPTION,
					JOptionPane.INFORMATION_MESSAGE);
            return;
        }
		
		int filterPtr = StringUtils.toInt(textFieldStartAddress.getText(), -1);
		int filterCnt = StringUtils.toInt(textFieldLength.getText(), -1);
		String filterData = textFieldData.getText();
		int filterBank = RFIDWithUHFUART.Bank_EPC;

        boolean res;
		if (filterCnt > 0 && StringUtils.isNotEmpty(filterData)) { // 过滤
            //----------------过滤----------------------------
        	if (filterPtr < 0) {
				JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_filter_start_address_must_be_decimal"), UHFDemo.rs.getString("kill"),
						JOptionPane.CLOSED_OPTION, JOptionPane.INFORMATION_MESSAGE);
				return;
			}
			int flag = filterCnt / 8 + (filterCnt % 8 == 0 ? 0 : 1);
			int dataLen = filterData.replace(" ", "").length() / 2;
			if (dataLen < flag) {
				JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_filter_length_error"), UHFDemo.rs.getString("kill"), JOptionPane.CLOSED_OPTION,
						JOptionPane.INFORMATION_MESSAGE);
				return;
			}

			if (rdbtnEpc.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_EPC;
			} else if (rdbtnTid.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_TID;
			} else if (rdbtnUser.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_USER;
			}
            res = UHFDemo.uhfReader.killTag(strPWD, filterBank, filterPtr, filterCnt, filterData);
		} else {
            res = UHFDemo.uhfReader.killTag(strPWD);
		}
		
        if(res) {
			JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_kill_succ"), UHFDemo.rs.getString("kill"), JOptionPane.CLOSED_OPTION,
					JOptionPane.INFORMATION_MESSAGE);
        } else {
			JOptionPane.showConfirmDialog(LockKillContainer.this, UHFDemo.rs.getString("msg_kill_fail"), UHFDemo.rs.getString("kill"), JOptionPane.CLOSED_OPTION,
					JOptionPane.INFORMATION_MESSAGE);
        }
	}
	
	@Override
	protected boolean showFilterButtons() {
		// TODO Auto-generated method stub
		return false;
	}
}
