package com.cw.uhf.container;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import com.cw.uhf.UHFDemo;
import com.cw.uhf.util.NumberTool;
import com.cw.uhf.util.StringUtils;
import com.rscja.deviceapi.RFIDWithUHFUART;

public class ReadWriteContainer extends BaseContainer {
	
	private JTextField textStartAddress;
	private JTextField textLength;
	private JTextField textPwd;
	private JTextField textData;

	private JComboBox comboBoxBank;

	private JTextField textStartAddress2;
	private JTextField textLength2;
	private JTextField textPwd2;
	private JTextField textData2;
	
	private JLabel labelBank, labelStartAddress, labelLength, labelWord, labelPwd, labelData;
	private JLabel labelBankErase, labelStartAddressErase, labelLengthErase, labelWordErase, labelPwdErase, labelDataErase;

	private JLabel labelDataLen;
	private JLabel labelDataLenErase;

	private JComboBox comboBoxBankErase;
	
	private JButton btnRead, btnWrite, btnErase, btnEraseWrite;
	private MouseAdapter mouseAdapter = new MouseAdapter() {
		public void mouseClicked(MouseEvent e) {
			if(!e.getComponent().isEnabled()) {
				return;
			}
			if(e.getComponent() == btnRead) {
				read();
			} else if (e.getComponent() == btnWrite) {
				write();
			} else if (e.getComponent() == btnErase) {
				erase();
			} else if (e.getComponent() == btnEraseWrite) {
				eraseWrite();
			}
		};
	};

	public ReadWriteContainer() {
		super();
		init();
	}

	private void init() {
		setBackground(UIManager.getColor("Button.highlight"));
		setBounds(12, 102, 1060, 690);
		setLayout(null);

		JPanel panel_1 = new JPanel();
		panel_1.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		panel_1.setBounds(0, 81, 532, 290);
		panel_1.setLayout(null);
		add(panel_1);

		labelBank = new JLabel("存储区：");
		labelBank.setBounds(12, 12, 80, 25);
		panel_1.add(labelBank);

		comboBoxBank = new JComboBox();
		comboBoxBank.setModel(new DefaultComboBoxModel(new String[] { "RESERVED", "EPC", "TID", "USER" }));
		comboBoxBank.setSelectedIndex(1);
		comboBoxBank.setBounds(120, 7, 250, 34);
		panel_1.add(comboBoxBank);

		labelStartAddress = new JLabel("起始地址：");
		labelStartAddress.setBounds(12, 59, 100, 25);
		panel_1.add(labelStartAddress);

		textStartAddress = new JTextField();
		textStartAddress.setText("2");
		textStartAddress.setBounds(120, 57, 250, 29);
		panel_1.add(textStartAddress);
		textStartAddress.setColumns(10);

		labelLength = new JLabel("长度：");
		labelLength.setBounds(12, 97, 80, 25);
		panel_1.add(labelLength);

		textLength = new JTextField();
		textLength.setText("6");
		textLength.setBounds(120, 98, 250, 29);
		panel_1.add(textLength);
		textLength.setColumns(10);

		labelWord = new JLabel("字");
		labelWord.setBounds(390, 97, 60, 25);
		panel_1.add(labelWord);

		labelPwd = new JLabel("密码：");
		labelPwd.setBounds(12, 137, 80, 25);
		panel_1.add(labelPwd);

		textPwd = new JTextField();
		textPwd.setText("00000000");
		textPwd.setBounds(120, 135, 250, 29);
		panel_1.add(textPwd);
		textPwd.setColumns(10);

		labelData = new JLabel("数据：");
		labelData.setBounds(12, 174, 80, 25);
		panel_1.add(labelData);

		textData = new JTextField();
		textData.setBounds(120, 176, 250, 29);
		panel_1.add(textData);
		textData.setColumns(10);
		textData.getDocument().addDocumentListener(new DocumentListener() {

			@Override
			public void removeUpdate(DocumentEvent e) {
				// TODO Auto-generated method stub
				labelDataLen.setText(String.valueOf(textData.getText().length() / 2));
			}

			@Override
			public void insertUpdate(DocumentEvent e) {
				// TODO Auto-generated method stub
				labelDataLen.setText(String.valueOf(textData.getText().length() / 2));
			}

			@Override
			public void changedUpdate(DocumentEvent e) {
				// TODO Auto-generated method stub
			}
		});

		labelDataLen = new JLabel("0");
		labelDataLen.setBounds(390, 174, 48, 25);
		panel_1.add(labelDataLen);

		btnRead = new JButton("读");
		btnRead.setEnabled(false);
		btnRead.setBounds(120, 234, 91, 35);
		btnRead.addMouseListener(mouseAdapter);
		panel_1.add(btnRead);

		btnWrite = new JButton("写");
		btnWrite.setEnabled(false);
		btnWrite.setBounds(279, 234, 91, 35);
		btnWrite.addMouseListener(mouseAdapter);
		panel_1.add(btnWrite);

		JPanel panel_2 = new JPanel();
		panel_2.setBackground(UIManager.getColor("OptionPane.questionDialog.titlePane.background"));
		panel_2.setBounds(544, 81, 516, 290);
		panel_2.setLayout(null);
		add(panel_2);

		labelBankErase = new JLabel("存储区：");
		labelBankErase.setBounds(12, 12, 80, 25);
		panel_2.add(labelBankErase);

		comboBoxBankErase = new JComboBox();
		comboBoxBankErase.setModel(new DefaultComboBoxModel(new String[] { "RESERVED", "EPC", "TID", "USER" }));
		comboBoxBankErase.setSelectedIndex(1);
		comboBoxBankErase.setBounds(120, 7, 250, 34);
		panel_2.add(comboBoxBankErase);

		labelStartAddressErase = new JLabel("起始地址：");
		labelStartAddressErase.setBounds(12, 55, 100, 25);
		panel_2.add(labelStartAddressErase);

		textStartAddress2 = new JTextField();
		textStartAddress2.setText("2");
		textStartAddress2.setColumns(10);
		textStartAddress2.setBounds(120, 53, 250, 29);
		panel_2.add(textStartAddress2);

		labelLengthErase = new JLabel("长度：");
		labelLengthErase.setBounds(12, 93, 80, 25);
		panel_2.add(labelLengthErase);

		textLength2 = new JTextField();
		textLength2.setText("6");
		textLength2.setColumns(10);
		textLength2.setBounds(120, 91, 250, 29);
		panel_2.add(textLength2);

		labelPwdErase = new JLabel("密码：");
		labelPwdErase.setBounds(12, 133, 80, 25);
		panel_2.add(labelPwdErase);

		textPwd2 = new JTextField();
		textPwd2.setText("00000000");
		textPwd2.setColumns(10);
		textPwd2.setBounds(120, 131, 250, 29);
		panel_2.add(textPwd2);

		labelDataErase = new JLabel("数据：");
		labelDataErase.setBounds(12, 170, 80, 25);
		panel_2.add(labelDataErase);

		textData2 = new JTextField();
		textData2.setColumns(10);
		textData2.setBounds(120, 168, 250, 29);
		panel_2.add(textData2);

		textData2.getDocument().addDocumentListener(new DocumentListener() {

			@Override
			public void removeUpdate(DocumentEvent e) {
				// TODO Auto-generated method stub
				labelDataLenErase.setText(String.valueOf(textData2.getText().length() / 2));
			}

			@Override
			public void insertUpdate(DocumentEvent e) {
				// TODO Auto-generated method stub
				labelDataLenErase.setText(String.valueOf(textData2.getText().length() / 2));
			}

			@Override
			public void changedUpdate(DocumentEvent e) {
				// TODO Auto-generated method stub
			}
		});

		labelWordErase = new JLabel("字");
		labelWordErase.setBounds(390, 93, 60, 25);
		panel_2.add(labelWordErase);

		labelDataLenErase = new JLabel("0");
		labelDataLenErase.setBounds(390, 170, 48, 25);
		panel_2.add(labelDataLenErase);

		btnErase = new JButton("擦除");
		btnErase.setEnabled(false);
		btnErase.setBounds(120, 234, 91, 35);
		btnErase.addMouseListener(mouseAdapter);
		panel_2.add(btnErase);

		btnEraseWrite = new JButton("写");
		btnEraseWrite.setEnabled(false);
		btnEraseWrite.setBounds(279, 234, 91, 35);
		btnEraseWrite.addMouseListener(mouseAdapter);
		panel_2.add(btnEraseWrite);
	}
	
	public void setBtnsEnabled(boolean enabled) {
		if(buttonSet != null)
			buttonSet.setEnabled(enabled);
		if(buttonReset != null)
			buttonReset.setEnabled(enabled);
		
		btnRead.setEnabled(enabled);
		btnWrite.setEnabled(enabled);
		btnErase.setEnabled(enabled);
		btnEraseWrite.setEnabled(enabled);
	}
	
	@Override
	public void updateLanguageUI() {
		// TODO Auto-generated method stub
		super.updateLanguageUI();
		labelBank.setText(UHFDemo.rs.getString("bank"));
		labelBankErase.setText(UHFDemo.rs.getString("bank"));
		labelStartAddress.setText(UHFDemo.rs.getString("startAddress"));
		labelStartAddressErase.setText(UHFDemo.rs.getString("startAddress"));
		labelLength.setText(UHFDemo.rs.getString("length"));
		labelLengthErase.setText(UHFDemo.rs.getString("length"));
		labelPwd.setText(UHFDemo.rs.getString("password"));
		labelPwdErase.setText(UHFDemo.rs.getString("password"));
		labelData.setText(UHFDemo.rs.getString("data"));
		labelDataErase.setText(UHFDemo.rs.getString("data"));
		labelWord.setText(UHFDemo.rs.getString("word"));
		labelWordErase.setText(UHFDemo.rs.getString("word"));
		
		btnRead.setText(UHFDemo.rs.getString("read"));
		btnWrite.setText(UHFDemo.rs.getString("write"));
		btnErase.setText(UHFDemo.rs.getString("erase"));
		btnEraseWrite.setText(UHFDemo.rs.getString("write"));
	}

	/**
	 * 读标签
	 */
	private void read() {
		String ptrStr = textStartAddress.getText().trim();
		if (ptrStr.equals("")) {
			JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_please_input_start_address"), UHFDemo.rs.getString("read"), JOptionPane.WARNING_MESSAGE);
			return;
		} else if (!NumberTool.isDecimal(ptrStr)) {
			JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_input_decimal_for_start_address"), UHFDemo.rs.getString("read"), JOptionPane.WARNING_MESSAGE);
			return;
		}

		String cntStr = textLength.getText().trim();
		if (cntStr.equals("")) {
			JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_please_enter_the_length"), UHFDemo.rs.getString("read"), JOptionPane.WARNING_MESSAGE);
			return;
		} else if (!NumberTool.isDecimal(cntStr)) {
			JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_input_decimal_for_length"), UHFDemo.rs.getString("read"), JOptionPane.WARNING_MESSAGE);
			return;
		}

		String pwdStr = textPwd.getText().trim();
		if (StringUtils.isNotEmpty(pwdStr)) {
			if (pwdStr.length() != 8) {
				JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_password_must_be_8_bits"), UHFDemo.rs.getString("read"), JOptionPane.WARNING_MESSAGE);
				return;
			} else if (!StringUtils.isHex(pwdStr)) {
				JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_password_must_be_hexadecimal"), UHFDemo.rs.getString("read"), JOptionPane.WARNING_MESSAGE);
				return;
			}
		} else {
			pwdStr = "00000000";
		}

		int storageArea = comboBoxBank.getSelectedIndex();
		String strReadData;
		int filterPtr = StringUtils.toInt(textFieldStartAddress.getText(), -1);
		int filterCnt = StringUtils.toInt(textFieldLength.getText(), -1);
		String filterData = textFieldData.getText();
		int filterBank = RFIDWithUHFUART.Bank_EPC;

		if (filterCnt > 0 && StringUtils.isNotEmpty(filterData)) { // 过滤
			if (filterPtr < 0) {
				JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_filter_start_address_must_be_decimal"), UHFDemo.rs.getString("read"), JOptionPane.WARNING_MESSAGE);
				return;
			}
			int flag = filterCnt / 8 + (filterCnt % 8 == 0 ? 0 : 1);
			int dataLen = filterData.replace(" ", "").length() / 2;
			if (dataLen < flag) {
				JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_filter_length_error"), UHFDemo.rs.getString("read"), JOptionPane.WARNING_MESSAGE);
				return;
			}

			if (rdbtnEpc.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_EPC;
			} else if (rdbtnTid.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_TID;
			} else if (rdbtnUser.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_USER;
			}
			strReadData = UHFDemo.uhfReader.readData(pwdStr, filterBank, filterPtr, filterCnt, filterData, storageArea,
					Integer.parseInt(ptrStr), Integer.parseInt(cntStr));
		} else {
			strReadData = UHFDemo.uhfReader.readData(pwdStr, storageArea, Integer.parseInt(ptrStr), Integer.parseInt(cntStr));
		}
		if (!StringUtils.isEmpty(strReadData)) {
			JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_read_succ"), UHFDemo.rs.getString("read"), JOptionPane.INFORMATION_MESSAGE);
			textData.setText(strReadData);
		} else {
			JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_read_fail"), UHFDemo.rs.getString("read"), JOptionPane.ERROR_MESSAGE);
			textData.setText("");
		}
	}

	/**
	 * 写标签
	 */
	private void write() {
		String ptrStr = textStartAddress.getText().trim();
		if (ptrStr.equals("")) {
			JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_please_input_start_address"), UHFDemo.rs.getString("write"), JOptionPane.WARNING_MESSAGE);
			return;
		} else if (!NumberTool.isDecimal(ptrStr)) {
			JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_input_decimal_for_start_address"), UHFDemo.rs.getString("write"), JOptionPane.WARNING_MESSAGE);
			return;
		}

		// 多字单次
		String cntStr = textLength.getText().trim();
		if (StringUtils.isEmpty(cntStr)) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_please_enter_the_length"), UHFDemo.rs.getString("write"), JOptionPane.CLOSED_OPTION,
					JOptionPane.WARNING_MESSAGE);
			return;
		} else if (!NumberTool.isDecimal(cntStr)) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_input_decimal_for_length"), UHFDemo.rs.getString("write"), JOptionPane.CLOSED_OPTION,
					JOptionPane.WARNING_MESSAGE);
			return;
		}

		String pwdStr = textPwd.getText().trim();// 访问密码
		if (StringUtils.isNotEmpty(pwdStr)) {
			if (pwdStr.length() != 8) {
				JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_password_must_be_8_bits"), UHFDemo.rs.getString("write"), JOptionPane.WARNING_MESSAGE);
				return;
			} else if (!StringUtils.isHex(pwdStr)) {
				JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_password_must_be_hexadecimal"), UHFDemo.rs.getString("write"), JOptionPane.WARNING_MESSAGE);
				return;
			}
		} else {
			pwdStr = "00000000";
		}

		String strData = textData.getText().trim();// 要写入的内容
		if (StringUtils.isEmpty(strData)) {
			JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_write_data_cannot_be_empty"), UHFDemo.rs.getString("write"), JOptionPane.WARNING_MESSAGE);
			return;
		} else if (!StringUtils.isHex(strData)) {
			JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_write_data_cannot_be_hexadecimal"), UHFDemo.rs.getString("write"), JOptionPane.WARNING_MESSAGE);
			return;
		}

		int storageArea = comboBoxBank.getSelectedIndex();
		int filterPtr = StringUtils.toInt(textFieldStartAddress.getText(), -1);
		int filterCnt = StringUtils.toInt(textFieldLength.getText(), -1);
		String filterData = textFieldData.getText();
		int filterBank = RFIDWithUHFUART.Bank_EPC;
		boolean result;

		if (filterCnt > 0 && StringUtils.isNotEmpty(filterData)) { // 过滤
			if (filterPtr < 0) {
				JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_filter_start_address_must_be_decimal"), UHFDemo.rs.getString("write"), JOptionPane.WARNING_MESSAGE);
				return;
			}
			int flag = filterCnt / 8 + (filterCnt % 8 == 0 ? 0 : 1);
			int dataLen = filterData.replace(" ", "").length() / 2;
			if (dataLen < flag) {
				JOptionPane.showMessageDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_filter_length_error"), UHFDemo.rs.getString("write"), JOptionPane.WARNING_MESSAGE);
				return;
			}

			if (rdbtnEpc.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_EPC;
			} else if (rdbtnTid.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_TID;
			} else if (rdbtnUser.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_USER;
			}
			// -----------------------------------------------------
			result = UHFDemo.uhfReader.writeData(pwdStr, filterBank, filterPtr, filterCnt, filterData, storageArea,
					Integer.parseInt(ptrStr), Integer.valueOf(cntStr), strData);
		} else {
			result = UHFDemo.uhfReader.writeData(pwdStr, storageArea, Integer.parseInt(ptrStr), Integer.valueOf(cntStr),
					strData);
		}

		if (result) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_write_succ"), UHFDemo.rs.getString("write"), JOptionPane.CLOSED_OPTION,
					JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_write_fail"), UHFDemo.rs.getString("write"), JOptionPane.CLOSED_OPTION,
					JOptionPane.ERROR_MESSAGE);
		}
	}

	private void erase() {
		String strPWD = textPwd2.getText().trim();// 访问密码
		if (StringUtils.isNotEmpty(strPWD)) {
			if (strPWD.length() != 8) {
				JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_password_must_be_8_bits"), UHFDemo.rs.getString("erase"), JOptionPane.CLOSED_OPTION,
						JOptionPane.WARNING_MESSAGE);
				return;
			} else if (!StringUtils.isHex(strPWD)) {
				JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_password_must_be_hexadecimal"), UHFDemo.rs.getString("erase"), JOptionPane.CLOSED_OPTION,
						JOptionPane.WARNING_MESSAGE);
				return;
			}
		} else {
			strPWD = "00000000";
		}

		String startAddress = textStartAddress2.getText().toString().trim();
		if (startAddress.equals("")) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_please_input_start_address"), UHFDemo.rs.getString("erase"), JOptionPane.CLOSED_OPTION,
					JOptionPane.WARNING_MESSAGE);
			return;
		} else if (!NumberTool.isDecimal(startAddress)) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_input_decimal_for_start_address"), UHFDemo.rs.getString("erase"), JOptionPane.CLOSED_OPTION,
					JOptionPane.WARNING_MESSAGE);
			return;
		}

		String startLen = textLength2.getText().toString().trim();
		if (StringUtils.isEmpty(startLen)) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_please_enter_the_length"), UHFDemo.rs.getString("erase"), JOptionPane.CLOSED_OPTION,
					JOptionPane.WARNING_MESSAGE);
			return;
		} else if (!NumberTool.isDecimal(startLen)) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_input_decimal_for_length"), UHFDemo.rs.getString("erase"), JOptionPane.CLOSED_OPTION,
					JOptionPane.WARNING_MESSAGE);
			return;
		}

		int eraseBank = comboBoxBankErase.getSelectedIndex();
		int filterPtr = StringUtils.toInt(textFieldStartAddress.getText(), -1);
		int filterCnt = StringUtils.toInt(textFieldLength.getText(), -1);
		String filterData = textFieldData.getText();
		int filterBank = RFIDWithUHFUART.Bank_EPC;
		boolean result = false;
		if (filterCnt > 0 && StringUtils.isNotEmpty(filterData)) { // 过滤
			if (filterPtr < 0) {
				JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_filter_start_address_must_be_decimal"), UHFDemo.rs.getString("erase"),
						JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
				return;
			}
			int flag = filterCnt / 8 + (filterCnt % 8 == 0 ? 0 : 1);
			int dataLen = filterData.replace(" ", "").length() / 2;
			if (dataLen < flag) {
				JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_filter_length_error"), UHFDemo.rs.getString("erase"), JOptionPane.CLOSED_OPTION,
						JOptionPane.WARNING_MESSAGE);
				return;
			}

			if (rdbtnEpc.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_EPC;
			} else if (rdbtnTid.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_TID;
			} else if (rdbtnUser.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_USER;
			}
			// -----------------------------------------------------
			result = UHFDemo.uhfReader.eraseData(strPWD, filterBank, filterPtr, filterCnt, filterData, eraseBank,
					Integer.valueOf(startAddress), Integer.valueOf(startLen));
		} else {
			result = UHFDemo.uhfReader.eraseData(strPWD, eraseBank, Integer.valueOf(startAddress),
					Integer.valueOf(startLen));
		}
		
		if (result) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_erase_succ"), UHFDemo.rs.getString("erase"), JOptionPane.CLOSED_OPTION,
					JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_erase_fail"), UHFDemo.rs.getString("erase"), JOptionPane.CLOSED_OPTION,
					JOptionPane.ERROR_MESSAGE);
		}
	}
	
	private void eraseWrite() {
		String strPWD = textPwd2.getText().trim();// 访问密码
		if (StringUtils.isNotEmpty(strPWD)) {
			if (strPWD.length() != 8) {
				JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_password_must_be_8_bits"), UHFDemo.rs.getString("eraseWrite"), JOptionPane.CLOSED_OPTION,
						JOptionPane.WARNING_MESSAGE);
				return;
			} else if (!StringUtils.isHex(strPWD)) {
				JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_password_must_be_hexadecimal"), UHFDemo.rs.getString("eraseWrite"), JOptionPane.CLOSED_OPTION,
						JOptionPane.WARNING_MESSAGE);
				return;
			}
		} else {
			strPWD = "00000000";
		}

		String startAddress = textStartAddress2.getText().toString().trim();
		if (startAddress.equals("")) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_please_input_start_address"), UHFDemo.rs.getString("eraseWrite"), JOptionPane.CLOSED_OPTION,
					JOptionPane.WARNING_MESSAGE);
			return;
		} else if (!NumberTool.isDecimal(startAddress)) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_input_decimal_for_start_address"), UHFDemo.rs.getString("eraseWrite"), JOptionPane.CLOSED_OPTION,
					JOptionPane.WARNING_MESSAGE);
			return;
		}

		String startLen = textLength2.getText().toString().trim();
		if (StringUtils.isEmpty(startLen)) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_please_enter_the_length"), UHFDemo.rs.getString("eraseWrite"), JOptionPane.CLOSED_OPTION,
					JOptionPane.WARNING_MESSAGE);
			return;
		} else if (!NumberTool.isDecimal(startLen)) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_input_decimal_for_length"), UHFDemo.rs.getString("eraseWrite"), JOptionPane.CLOSED_OPTION,
					JOptionPane.WARNING_MESSAGE);
			return;
		}

		String strData = textData2.getText().trim();// 要写入的内容
		if (StringUtils.isEmpty(strData)) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_write_data_cannot_be_empty"), UHFDemo.rs.getString("eraseWrite"), JOptionPane.CLOSED_OPTION,
					JOptionPane.WARNING_MESSAGE);
			return;
		} else if (!StringUtils.isHex(strData)) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_write_data_cannot_be_hexadecimal"), UHFDemo.rs.getString("eraseWrite"), JOptionPane.CLOSED_OPTION,
					JOptionPane.WARNING_MESSAGE);
			return;
		}

		int eraseBank = comboBoxBankErase.getSelectedIndex();
		int filterPtr = StringUtils.toInt(textFieldStartAddress.getText(), -1);
		int filterCnt = StringUtils.toInt(textFieldLength.getText(), -1);
		String filterData = textFieldData.getText();
		int filterBank = RFIDWithUHFUART.Bank_EPC;
		boolean result = false;
		if (filterCnt > 0 && StringUtils.isNotEmpty(filterData)) { // 过滤
			if (filterPtr < 0) {
				JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_filter_start_address_must_be_decimal"), UHFDemo.rs.getString("eraseWrite"),
						JOptionPane.CLOSED_OPTION, JOptionPane.WARNING_MESSAGE);
				return;
			}
			int flag = filterCnt / 8 + (filterCnt % 8 == 0 ? 0 : 1);
			int dataLen = filterData.replace(" ", "").length() / 2;
			if (dataLen < flag) {
				JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_filter_length_error"), UHFDemo.rs.getString("eraseWrite"), JOptionPane.CLOSED_OPTION,
						JOptionPane.WARNING_MESSAGE);
				return;
			}

			if (rdbtnEpc.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_EPC;
			} else if (rdbtnTid.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_TID;
			} else if (rdbtnUser.isSelected()) {
				filterBank = RFIDWithUHFUART.Bank_USER;
			}
			// -----------------------------------------------------
			result = UHFDemo.uhfReader.blockWriteData(strPWD, filterBank, filterPtr, filterCnt, filterData, 
					eraseBank, Integer.valueOf(startAddress), Integer.valueOf(startLen), strData);
		} else {
			result = UHFDemo.uhfReader.blockWriteData(strPWD, eraseBank, Integer.valueOf(startAddress), Integer.valueOf(startLen), strData);
		}
		
		if (result) {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_erase_write_succ"), UHFDemo.rs.getString("eraseWrite"), JOptionPane.CLOSED_OPTION,
					JOptionPane.INFORMATION_MESSAGE);
		} else {
			JOptionPane.showConfirmDialog(ReadWriteContainer.this, UHFDemo.rs.getString("msg_erase_write_fail"), UHFDemo.rs.getString("eraseWrite"), JOptionPane.CLOSED_OPTION,
					JOptionPane.ERROR_MESSAGE);
		}
	}

	@Override
	protected boolean showFilterButtons() {
		// TODO Auto-generated method stub
		return false;
	}
}
