package com.cw.uhf.model;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

import com.rscja.deviceapi.entity.UHFTAGInfo;

public class InventoryTableModel extends AbstractTableModel {

	private List<UHFTAGInfo> uhftagInfoList;
	
	private Map<String, Integer> countMap = new HashMap<String, Integer>();
	
	public String[] columnNames = { "INDEX", "EPC", "TID", "RSSI", "Count", "Ant" };

	public InventoryTableModel() {
		this(null);
	}

	public InventoryTableModel(List<UHFTAGInfo> uhftagInfoList) {
		this.uhftagInfoList = uhftagInfoList;
	}

	public void setDataList(List<UHFTAGInfo> uhftagInfoList) {
		this.uhftagInfoList = uhftagInfoList;
	}

	@Override
	public int getRowCount() {
		// TODO Auto-generated method stub
		if (uhftagInfoList != null) {
			return uhftagInfoList.size();
		}
		return 0;
	}
	

	@Override
	public int getColumnCount() {
		// TODO Auto-generated method stub
		return columnNames.length;
	}

	@Override
	public String getColumnName(int columnIndex) {
		// TODO Auto-generated method stub
		return columnNames[columnIndex];
	}

	@Override
	public Object getValueAt(int rowIndex, int columnIndex) {
		// TODO Auto-generated method stub
		if (uhftagInfoList != null) {
			UHFTAGInfo uhftagInfo = uhftagInfoList.get(rowIndex);
			switch (columnIndex) {
			case 0:
				return String.valueOf(rowIndex + 1);
			case 1:
				return uhftagInfo.getEPC();
			case 2:
				return uhftagInfo.getTid();
			case 3:
				return uhftagInfo.getRssi();
			case 4:
				return countMap.get(uhftagInfo.getEPC());
			case 5:
				return uhftagInfo.getAnt();

			default:
				break;
			}
		}
		return null;
	}

	@Override
	public boolean isCellEditable(int rowIndex, int columnIndex) {
		// TODO Auto-generated method stub
		if(columnIndex == 1) {
			return true;
		}
		return super.isCellEditable(rowIndex, columnIndex);
	}
	
	public void putTagCount(String epc) {
		if(countMap.containsKey(epc)) {
			countMap.put(epc, countMap.get(epc) + 1);
		} else {
			countMap.put(epc, 1);
		}
	}
	
	public void clear() {
		countMap.clear();
	}
}
